#include "clisp.h"

extern gcv_object_t module__linux__object_tab[];
#include <stddef.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <errno.h>
static int *clisp_errno_location(void);
static int *clisp_errno_location() { return &errno; }
#include <stdlib.h>
extern float strtof(const char *, char **);
extern long long int llabs (long long int);
#include <ctype.h>
#include <math.h>
#include <unistd.h>
extern char **environ;
#include <sys/wait.h>
#include <getopt.h>
#include <fcntl.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <stdio.h>
#include <dirent.h>
#ifndef __USE_FILE_OFFSET64
typedef __ino_t clisp_dirent_ino_t;
typedef __off_t clisp_dirent_off_t;
#else
typedef __ino64_t clisp_dirent_ino_t;
typedef __off64_t clisp_dirent_off_t;
#endif
#include <pwd.h>
#include <grp.h>
#include <sys/utsname.h>
#include <termios.h>
#include <string.h>
#include <sys/ioctl.h>
#include <signal.h>

subr_t module__linux__subr_tab[1];
uintC module__linux__subr_tab_size = 0;
subr_initdata_t module__linux__subr_tab_initdata[1];

gcv_object_t module__linux__object_tab[1];
object_initdata_t module__linux__object_tab_initdata[1];
uintC module__linux__object_tab_size = 0;

long MODULE__LINUX__CONSTANT_MAP_LONG (int number, int *definedp);
long MODULE__LINUX__CONSTANT_MAP_LONG (int number, int *definedp) {
  *definedp=1;
  switch (number) {
# if defined(EPERM)
    case 0: return EPERM;
# endif
# if defined(ENOENT)
    case 1: return ENOENT;
# endif
# if defined(ESRCH)
    case 2: return ESRCH;
# endif
# if defined(EINTR)
    case 3: return EINTR;
# endif
# if defined(EIO)
    case 4: return EIO;
# endif
# if defined(ENXIO)
    case 5: return ENXIO;
# endif
# if defined(E2BIG)
    case 6: return E2BIG;
# endif
# if defined(ENOEXEC)
    case 7: return ENOEXEC;
# endif
# if defined(EBADF)
    case 8: return EBADF;
# endif
# if defined(ECHILD)
    case 9: return ECHILD;
# endif
# if defined(EAGAIN)
    case 10: return EAGAIN;
# endif
# if defined(ENOMEM)
    case 11: return ENOMEM;
# endif
# if defined(EACCES)
    case 12: return EACCES;
# endif
# if defined(EFAULT)
    case 13: return EFAULT;
# endif
# if defined(ENOTBLK)
    case 14: return ENOTBLK;
# endif
# if defined(EBUSY)
    case 15: return EBUSY;
# endif
# if defined(EEXIST)
    case 16: return EEXIST;
# endif
# if defined(EXDEV)
    case 17: return EXDEV;
# endif
# if defined(ENODEV)
    case 18: return ENODEV;
# endif
# if defined(ENOTDIR)
    case 19: return ENOTDIR;
# endif
# if defined(EISDIR)
    case 20: return EISDIR;
# endif
# if defined(EINVAL)
    case 21: return EINVAL;
# endif
# if defined(ENFILE)
    case 22: return ENFILE;
# endif
# if defined(EMFILE)
    case 23: return EMFILE;
# endif
# if defined(ENOTTY)
    case 24: return ENOTTY;
# endif
# if defined(ETXTBSY)
    case 25: return ETXTBSY;
# endif
# if defined(EFBIG)
    case 26: return EFBIG;
# endif
# if defined(ENOSPC)
    case 27: return ENOSPC;
# endif
# if defined(ESPIPE)
    case 28: return ESPIPE;
# endif
# if defined(EROFS)
    case 29: return EROFS;
# endif
# if defined(EMLINK)
    case 30: return EMLINK;
# endif
# if defined(EPIPE)
    case 31: return EPIPE;
# endif
# if defined(EDOM)
    case 32: return EDOM;
# endif
# if defined(ERANGE)
    case 33: return ERANGE;
# endif
# if defined(EDEADLK)
    case 34: return EDEADLK;
# endif
# if defined(ENAMETOOLONG)
    case 35: return ENAMETOOLONG;
# endif
# if defined(ENOLCK)
    case 36: return ENOLCK;
# endif
# if defined(ENOSYS)
    case 37: return ENOSYS;
# endif
# if defined(ENOTEMPTY)
    case 38: return ENOTEMPTY;
# endif
# if defined(ELOOP)
    case 39: return ELOOP;
# endif
# if defined(EWOULDBLOCK)
    case 40: return EWOULDBLOCK;
# endif
# if defined(ENOMSG)
    case 41: return ENOMSG;
# endif
# if defined(EIDRM)
    case 42: return EIDRM;
# endif
# if defined(ECHRNG)
    case 43: return ECHRNG;
# endif
# if defined(EL2NSYNC)
    case 44: return EL2NSYNC;
# endif
# if defined(EL3HLT)
    case 45: return EL3HLT;
# endif
# if defined(EL3RST)
    case 46: return EL3RST;
# endif
# if defined(ELNRNG)
    case 47: return ELNRNG;
# endif
# if defined(EUNATCH)
    case 48: return EUNATCH;
# endif
# if defined(ENOCSI)
    case 49: return ENOCSI;
# endif
# if defined(EL2HLT)
    case 50: return EL2HLT;
# endif
# if defined(EBADE)
    case 51: return EBADE;
# endif
# if defined(EBADR)
    case 52: return EBADR;
# endif
# if defined(EXFULL)
    case 53: return EXFULL;
# endif
# if defined(ENOANO)
    case 54: return ENOANO;
# endif
# if defined(EBADRQC)
    case 55: return EBADRQC;
# endif
# if defined(EBADSLT)
    case 56: return EBADSLT;
# endif
# if defined(EDEADLOCK)
    case 57: return EDEADLOCK;
# endif
# if defined(EBFONT)
    case 58: return EBFONT;
# endif
# if defined(ENOSTR)
    case 59: return ENOSTR;
# endif
# if defined(ENODATA)
    case 60: return ENODATA;
# endif
# if defined(ETIME)
    case 61: return ETIME;
# endif
# if defined(ENOSR)
    case 62: return ENOSR;
# endif
# if defined(ENONET)
    case 63: return ENONET;
# endif
# if defined(ENOPKG)
    case 64: return ENOPKG;
# endif
# if defined(EREMOTE)
    case 65: return EREMOTE;
# endif
# if defined(ENOLINK)
    case 66: return ENOLINK;
# endif
# if defined(EADV)
    case 67: return EADV;
# endif
# if defined(ESRMNT)
    case 68: return ESRMNT;
# endif
# if defined(ECOMM)
    case 69: return ECOMM;
# endif
# if defined(EPROTO)
    case 70: return EPROTO;
# endif
# if defined(EMULTIHOP)
    case 71: return EMULTIHOP;
# endif
# if defined(EDOTDOT)
    case 72: return EDOTDOT;
# endif
# if defined(EBADMSG)
    case 73: return EBADMSG;
# endif
# if defined(EOVERFLOW)
    case 74: return EOVERFLOW;
# endif
# if defined(ENOTUNIQ)
    case 75: return ENOTUNIQ;
# endif
# if defined(EBADFD)
    case 76: return EBADFD;
# endif
# if defined(EREMCHG)
    case 77: return EREMCHG;
# endif
# if defined(ELIBACC)
    case 78: return ELIBACC;
# endif
# if defined(ELIBBAD)
    case 79: return ELIBBAD;
# endif
# if defined(ELIBSCN)
    case 80: return ELIBSCN;
# endif
# if defined(ELIBMAX)
    case 81: return ELIBMAX;
# endif
# if defined(ELIBEXEC)
    case 82: return ELIBEXEC;
# endif
# if defined(EILSEQ)
    case 83: return EILSEQ;
# endif
# if defined(ERESTART)
    case 84: return ERESTART;
# endif
# if defined(ESTRPIPE)
    case 85: return ESTRPIPE;
# endif
# if defined(EUSERS)
    case 86: return EUSERS;
# endif
# if defined(ENOTSOCK)
    case 87: return ENOTSOCK;
# endif
# if defined(EDESTADDRREQ)
    case 88: return EDESTADDRREQ;
# endif
# if defined(EMSGSIZE)
    case 89: return EMSGSIZE;
# endif
# if defined(EPROTOTYPE)
    case 90: return EPROTOTYPE;
# endif
# if defined(ENOPROTOOPT)
    case 91: return ENOPROTOOPT;
# endif
# if defined(EPROTONOSUPPORT)
    case 92: return EPROTONOSUPPORT;
# endif
# if defined(ESOCKTNOSUPPORT)
    case 93: return ESOCKTNOSUPPORT;
# endif
# if defined(EOPNOTSUPP)
    case 94: return EOPNOTSUPP;
# endif
# if defined(EPFNOSUPPORT)
    case 95: return EPFNOSUPPORT;
# endif
# if defined(EAFNOSUPPORT)
    case 96: return EAFNOSUPPORT;
# endif
# if defined(EADDRINUSE)
    case 97: return EADDRINUSE;
# endif
# if defined(EADDRNOTAVAIL)
    case 98: return EADDRNOTAVAIL;
# endif
# if defined(ENETDOWN)
    case 99: return ENETDOWN;
# endif
# if defined(ENETUNREACH)
    case 100: return ENETUNREACH;
# endif
# if defined(ENETRESET)
    case 101: return ENETRESET;
# endif
# if defined(ECONNABORTED)
    case 102: return ECONNABORTED;
# endif
# if defined(ECONNRESET)
    case 103: return ECONNRESET;
# endif
# if defined(ENOBUFS)
    case 104: return ENOBUFS;
# endif
# if defined(EISCONN)
    case 105: return EISCONN;
# endif
# if defined(ENOTCONN)
    case 106: return ENOTCONN;
# endif
# if defined(ESHUTDOWN)
    case 107: return ESHUTDOWN;
# endif
# if defined(ETOOMANYREFS)
    case 108: return ETOOMANYREFS;
# endif
# if defined(ETIMEDOUT)
    case 109: return ETIMEDOUT;
# endif
# if defined(ECONNREFUSED)
    case 110: return ECONNREFUSED;
# endif
# if defined(EHOSTDOWN)
    case 111: return EHOSTDOWN;
# endif
# if defined(EHOSTUNREACH)
    case 112: return EHOSTUNREACH;
# endif
# if defined(EALREADY)
    case 113: return EALREADY;
# endif
# if defined(EINPROGRESS)
    case 114: return EINPROGRESS;
# endif
# if defined(ESTALE)
    case 115: return ESTALE;
# endif
# if defined(EUCLEAN)
    case 116: return EUCLEAN;
# endif
# if defined(ENOTNAM)
    case 117: return ENOTNAM;
# endif
# if defined(ENAVAIL)
    case 118: return ENAVAIL;
# endif
# if defined(EISNAM)
    case 119: return EISNAM;
# endif
# if defined(EREMOTEIO)
    case 120: return EREMOTEIO;
# endif
# if defined(EDQUOT)
    case 121: return EDQUOT;
# endif
# if defined(ENOMEDIUM)
    case 122: return ENOMEDIUM;
# endif
# if defined(EMEDIUMTYPE)
    case 123: return EMEDIUMTYPE;
# endif
# if defined(ECANCELED)
    case 124: return ECANCELED;
# endif
# if defined(ENOKEY)
    case 125: return ENOKEY;
# endif
# if defined(EKEYEXPIRED)
    case 126: return EKEYEXPIRED;
# endif
# if defined(EKEYREVOKED)
    case 127: return EKEYREVOKED;
# endif
# if defined(EKEYREJECTED)
    case 128: return EKEYREJECTED;
# endif
# if defined(EOWNERDEAD)
    case 129: return EOWNERDEAD;
# endif
# if defined(ENOTRECOVERABLE)
    case 130: return ENOTRECOVERABLE;
# endif
# if defined(DT_UNKNOWN)
    case 131: return DT_UNKNOWN;
# endif
# if defined(DT_FIFO)
    case 132: return DT_FIFO;
# endif
# if defined(DT_CHR)
    case 133: return DT_CHR;
# endif
# if defined(DT_DIR)
    case 134: return DT_DIR;
# endif
# if defined(DT_BLK)
    case 135: return DT_BLK;
# endif
# if defined(DT_REG)
    case 136: return DT_REG;
# endif
# if defined(DT_LNK)
    case 137: return DT_LNK;
# endif
# if defined(DT_SOCK)
    case 138: return DT_SOCK;
# endif
# if defined(MAXNAMLEN)
    case 139: return MAXNAMLEN;
# endif
# if defined(SIGHUP)
    case 140: return SIGHUP;
# endif
# if defined(SIGINT)
    case 141: return SIGINT;
# endif
# if defined(SIGQUIT)
    case 142: return SIGQUIT;
# endif
# if defined(SIGILL)
    case 143: return SIGILL;
# endif
# if defined(SIGTRAP)
    case 144: return SIGTRAP;
# endif
# if defined(SIGABRT)
    case 145: return SIGABRT;
# endif
# if defined(SIGIOT)
    case 146: return SIGIOT;
# endif
# if defined(SIGBUS)
    case 147: return SIGBUS;
# endif
# if defined(SIGFPE)
    case 148: return SIGFPE;
# endif
# if defined(SIGKILL)
    case 149: return SIGKILL;
# endif
# if defined(SIGUSR1)
    case 150: return SIGUSR1;
# endif
# if defined(SIGSEGV)
    case 151: return SIGSEGV;
# endif
# if defined(SIGUSR2)
    case 152: return SIGUSR2;
# endif
# if defined(SIGPIPE)
    case 153: return SIGPIPE;
# endif
# if defined(SIGALRM)
    case 154: return SIGALRM;
# endif
# if defined(SIGTERM)
    case 155: return SIGTERM;
# endif
# if defined(SIGSTKFLT)
    case 156: return SIGSTKFLT;
# endif
# if defined(SIGCHLD)
    case 157: return SIGCHLD;
# endif
# if defined(SIGCLD)
    case 158: return SIGCLD;
# endif
# if defined(SIGCONT)
    case 159: return SIGCONT;
# endif
# if defined(SIGSTOP)
    case 160: return SIGSTOP;
# endif
# if defined(SIGTSTP)
    case 161: return SIGTSTP;
# endif
# if defined(SIGTTIN)
    case 162: return SIGTTIN;
# endif
# if defined(SIGTTOU)
    case 163: return SIGTTOU;
# endif
# if defined(SIGURG)
    case 164: return SIGURG;
# endif
# if defined(SIGXCPU)
    case 165: return SIGXCPU;
# endif
# if defined(SIGXFSZ)
    case 166: return SIGXFSZ;
# endif
# if defined(SIGVTALRM)
    case 167: return SIGVTALRM;
# endif
# if defined(SIGPROF)
    case 168: return SIGPROF;
# endif
# if defined(SIGWINCH)
    case 169: return SIGWINCH;
# endif
# if defined(SIGIO)
    case 170: return SIGIO;
# endif
# if defined(SIGPOLL)
    case 171: return SIGPOLL;
# endif
# if defined(SIGPWR)
    case 172: return SIGPWR;
# endif
# if defined(SIGSYS)
    case 173: return SIGSYS;
# endif
# if defined(SIGUNUSED)
    case 174: return SIGUNUSED;
# endif
# if defined(_NSIG)
    case 175: return _NSIG;
# endif
    default: *definedp=0; return 0;
  }
}

void module__linux__init_function_1 (module_t* module);
void module__linux__init_function_2 (module_t* module);
void module__linux__fini_function (module_t* module);

void module__linux__init_function_1 (module_t* module)
{
  (void)module; /* avoid -Wunused-parameter */

  register_foreign_inttype("tcflag_t",sizeof(tcflag_t),(tcflag_t)-1<=(tcflag_t)0);
  register_foreign_inttype("speed_t",sizeof(speed_t),(speed_t)-1<=(speed_t)0);
  register_foreign_inttype("cc_t",sizeof(cc_t),(cc_t)-1<=(cc_t)0);
  register_foreign_inttype("clisp_dirent_off_t",sizeof(clisp_dirent_off_t),(clisp_dirent_off_t)-1<=(clisp_dirent_off_t)0);
  register_foreign_inttype("clisp_dirent_ino_t",sizeof(clisp_dirent_ino_t),(clisp_dirent_ino_t)-1<=(clisp_dirent_ino_t)0);
  register_foreign_inttype("__off_t",sizeof(__off_t),(__off_t)-1<=(__off_t)0);
  register_foreign_inttype("__time_t",sizeof(__time_t),(__time_t)-1<=(__time_t)0);
  register_foreign_inttype("__key_t",sizeof(__key_t),(__key_t)-1<=(__key_t)0);
  register_foreign_inttype("__caddr_t",sizeof(__caddr_t),(__caddr_t)-1<=(__caddr_t)0);
  register_foreign_inttype("__daddr_t",sizeof(__daddr_t),(__daddr_t)-1<=(__daddr_t)0);
  register_foreign_inttype("__uid_t",sizeof(__uid_t),(__uid_t)-1<=(__uid_t)0);
  register_foreign_inttype("__pid_t",sizeof(__pid_t),(__pid_t)-1<=(__pid_t)0);
  register_foreign_inttype("__loff_t",sizeof(__loff_t),(__loff_t)-1<=(__loff_t)0);
  register_foreign_inttype("off64_t",sizeof(off64_t),(off64_t)-1<=(off64_t)0);
  register_foreign_inttype("__nlink_t",sizeof(__nlink_t),(__nlink_t)-1<=(__nlink_t)0);
  register_foreign_inttype("__mode_t",sizeof(__mode_t),(__mode_t)-1<=(__mode_t)0);
  register_foreign_inttype("ino64_t",sizeof(ino64_t),(ino64_t)-1<=(ino64_t)0);
  register_foreign_inttype("__ino_t",sizeof(__ino_t),(__ino_t)-1<=(__ino_t)0);
  register_foreign_inttype("__gid_t",sizeof(__gid_t),(__gid_t)-1<=(__gid_t)0);
  register_foreign_inttype("__dev_t",sizeof(__dev_t),(__dev_t)-1<=(__dev_t)0);
  register_foreign_inttype("__ipc_pid_t",sizeof(__ipc_pid_t),(__ipc_pid_t)-1<=(__ipc_pid_t)0);
  register_foreign_inttype("__ssize_t",sizeof(__ssize_t),(__ssize_t)-1<=(__ssize_t)0);
  register_foreign_inttype("wchar_t",sizeof(wchar_t),(wchar_t)-1<=(wchar_t)0);
  register_foreign_inttype("ptrdiff_t",sizeof(ptrdiff_t),(ptrdiff_t)-1<=(ptrdiff_t)0);
}

void module__linux__init_function_2 (module_t* module)
{
  (void)module; /* avoid -Wunused-parameter */

  register_foreign_variable((void*)&signgam,"signgam",0,sizeof(signgam));
  register_foreign_variable((void*)&environ,"environ",1,sizeof(environ));
  register_foreign_variable((void*)&opterr,"opterr",0,sizeof(opterr));
  register_foreign_variable((void*)&optind,"optind",0,sizeof(optind));
  register_foreign_variable((void*)&optopt,"optopt",0,sizeof(optopt));
  register_foreign_variable((void*)&optarg,"optarg",0,sizeof(optarg));
  register_foreign_variable((void*)&stdin,"stdin",0,sizeof(stdin));
  register_foreign_variable((void*)&stdout,"stdout",0,sizeof(stdout));
  register_foreign_variable((void*)&stderr,"stderr",0,sizeof(stderr));
  register_foreign_function((void*)&clisp_errno_location,"clisp_errno_location",1024);
  register_foreign_function((void*)&__ctype_get_mb_cur_max,"__ctype_get_mb_cur_max",1024);
  register_foreign_function((void*)&atof,"atof",1024);
  register_foreign_function((void*)&atoi,"atoi",1024);
  register_foreign_function((void*)&atol,"atol",1024);
  register_foreign_function((void*)&atoll,"atoll",1024);
  register_foreign_function((void*)&strtod,"strtod",1024);
  register_foreign_function((void*)&strtof,"strtof",1024);
  register_foreign_function((void*)&strtol,"strtol",1024);
  register_foreign_function((void*)&strtoul,"strtoul",1024);
  register_foreign_function((void*)&strtoq,"strtoq",1024);
  register_foreign_function((void*)&strtouq,"strtouq",1024);
  register_foreign_function((void*)&strtoll,"strtoll",1024);
  register_foreign_function((void*)&strtoull,"strtoull",1024);
  register_foreign_function((void*)&l64a,"l64a",1024);
  register_foreign_function((void*)&a64l,"a64l",1024);
  register_foreign_function((void*)&random,"random",1024);
  register_foreign_function((void*)&srandom,"srandom",1024);
  register_foreign_function((void*)&initstate,"initstate",1024);
  register_foreign_function((void*)&setstate,"setstate",1024);
  register_foreign_function((void*)&random_r,"random_r",1024);
  register_foreign_function((void*)&srandom_r,"srandom_r",1024);
  register_foreign_function((void*)&initstate_r,"initstate_r",1024);
  register_foreign_function((void*)&setstate_r,"setstate_r",1024);
  register_foreign_function((void*)&rand,"rand",1024);
  register_foreign_function((void*)&srand,"srand",1024);
  register_foreign_function((void*)&rand_r,"rand_r",1024);
  register_foreign_function((void*)&drand48,"drand48",1024);
  register_foreign_function((void*)&erand48,"erand48",1024);
  register_foreign_function((void*)&lrand48,"lrand48",1024);
  register_foreign_function((void*)&nrand48,"nrand48",1024);
  register_foreign_function((void*)&mrand48,"mrand48",1024);
  register_foreign_function((void*)&jrand48,"jrand48",1024);
  register_foreign_function((void*)&srand48,"srand48",1024);
  register_foreign_function((void*)&seed48,"seed48",1024);
  register_foreign_function((void*)&lcong48,"lcong48",1024);
  register_foreign_function((void*)&drand48_r,"drand48_r",1024);
  register_foreign_function((void*)&erand48_r,"erand48_r",1024);
  register_foreign_function((void*)&lrand48_r,"lrand48_r",1024);
  register_foreign_function((void*)&nrand48_r,"nrand48_r",1024);
  register_foreign_function((void*)&mrand48_r,"mrand48_r",1024);
  register_foreign_function((void*)&jrand48_r,"jrand48_r",1024);
  register_foreign_function((void*)&srand48_r,"srand48_r",1024);
  register_foreign_function((void*)&seed48_r,"seed48_r",1024);
  register_foreign_function((void*)&lcong48_r,"lcong48_r",1024);
  register_foreign_function((void*)&malloc,"malloc",1024);
  register_foreign_function((void*)&realloc,"realloc",1024);
  register_foreign_function((void*)&calloc,"calloc",1024);
  register_foreign_function((void*)&free,"free",1024);
  register_foreign_function((void*)&valloc,"valloc",1024);
  register_foreign_function((void*)&abort,"abort",1024);
  register_foreign_function((void*)&atexit,"atexit",1024);
  register_foreign_function((void*)&on_exit,"on_exit",1024);
  register_foreign_function((void*)&exit,"exit",1024);
  register_foreign_function((void*)&getenv,"getenv",1024);
  register_foreign_function((void*)&putenv,"putenv",1024);
  register_foreign_function((void*)&setenv,"setenv",1024);
  register_foreign_function((void*)&unsetenv,"unsetenv",1024);
  register_foreign_function((void*)&clearenv,"clearenv",1024);
  register_foreign_function((void*)&mktemp,"mktemp",1024);
  register_foreign_function((void*)&mkstemp,"mkstemp",1024);
  register_foreign_function((void*)&system,"system",1024);
# if defined(__USE_GNU)
  register_foreign_function((void*)&canonicalize_file_name,"canonicalize_file_name",1026);
# endif
  register_foreign_function((void*)&realpath,"realpath",1024);
  register_foreign_function((void*)&bsearch,"bsearch",1024);
  register_foreign_function((void*)&qsort,"qsort",1024);
  register_foreign_function((void*)&abs,"abs",1024);
  register_foreign_function((void*)&labs,"labs",1024);
  register_foreign_function((void*)&llabs,"llabs",1024);
  register_foreign_function((void*)&div,"div",1024);
  register_foreign_function((void*)&ldiv,"ldiv",1024);
  register_foreign_function((void*)&ecvt,"ecvt",1024);
  register_foreign_function((void*)&fcvt,"fcvt",1024);
  register_foreign_function((void*)&gcvt,"gcvt",1024);
  register_foreign_function((void*)&mblen,"mblen",1024);
  register_foreign_function((void*)&mbtowc,"mbtowc",1024);
  register_foreign_function((void*)&rpmatch,"rpmatch",1024);
  register_foreign_function((void*)&isalnum,"isalnum",1024);
  register_foreign_function((void*)&isalpha,"isalpha",1024);
  register_foreign_function((void*)&iscntrl,"iscntrl",1024);
  register_foreign_function((void*)&isdigit,"isdigit",1024);
  register_foreign_function((void*)&islower,"islower",1024);
  register_foreign_function((void*)&isgraph,"isgraph",1024);
  register_foreign_function((void*)&isprint,"isprint",1024);
  register_foreign_function((void*)&ispunct,"ispunct",1024);
  register_foreign_function((void*)&isspace,"isspace",1024);
  register_foreign_function((void*)&isupper,"isupper",1024);
  register_foreign_function((void*)&isxdigit,"isxdigit",1024);
  register_foreign_function((void*)&tolower,"tolower",1024);
  register_foreign_function((void*)&toupper,"toupper",1024);
  register_foreign_function((void*)&isascii,"isascii",1024);
  register_foreign_function((void*)&toascii,"toascii",1024);
  register_foreign_function((void*)&_tolower,"_tolower",1024);
  register_foreign_function((void*)&_toupper,"_toupper",1024);
  register_foreign_function((void*)&acos,"acos",1024);
  register_foreign_function((void*)&asin,"asin",1024);
  register_foreign_function((void*)&atan,"atan",1024);
  register_foreign_function((void*)&atan2,"atan2",1024);
  register_foreign_function((void*)&cos,"cos",1024);
  register_foreign_function((void*)&sin,"sin",1024);
  register_foreign_function((void*)&tan,"tan",1024);
  register_foreign_function((void*)&cosh,"cosh",1024);
  register_foreign_function((void*)&sinh,"sinh",1024);
  register_foreign_function((void*)&tanh,"tanh",1024);
  register_foreign_function((void*)&acosh,"acosh",1024);
  register_foreign_function((void*)&asinh,"asinh",1024);
  register_foreign_function((void*)&atanh,"atanh",1024);
  register_foreign_function((void*)&exp,"exp",1024);
  register_foreign_function((void*)&frexp,"frexp",1024);
  register_foreign_function((void*)&ldexp,"ldexp",1024);
  register_foreign_function((void*)&log,"log",1024);
  register_foreign_function((void*)&log10,"log10",1024);
  register_foreign_function((void*)&expm1,"expm1",1024);
  register_foreign_function((void*)&log1p,"log1p",1024);
  register_foreign_function((void*)&logb,"logb",1024);
  register_foreign_function((void*)&modf,"modf",1024);
  register_foreign_function((void*)&pow,"pow",1024);
  register_foreign_function((void*)&sqrt,"sqrt",1024);
  register_foreign_function((void*)&cbrt,"cbrt",1024);
  register_foreign_function((void*)&ceil,"ceil",1024);
  register_foreign_function((void*)&fabs,"fabs",1024);
  register_foreign_function((void*)&floor,"floor",1024);
  register_foreign_function((void*)&fmod,"fmod",1024);
  register_foreign_function((void*)&isinf,"isinf",1024);
  register_foreign_function((void*)&finite,"finite",1024);
  register_foreign_function((void*)&copysign,"copysign",1024);
  register_foreign_function((void*)&scalbn,"scalbn",1024);
  register_foreign_function((void*)&drem,"drem",1024);
  register_foreign_function((void*)&significand,"significand",1024);
  register_foreign_function((void*)&isnan,"isnan",1024);
  register_foreign_function((void*)&ilogb,"ilogb",1024);
  register_foreign_function((void*)&hypot,"hypot",1024);
  register_foreign_function((void*)&erf,"erf",1024);
  register_foreign_function((void*)&erfc,"erfc",1024);
  register_foreign_function((void*)&gamma,"gamma",1024);
  register_foreign_function((void*)&j0,"j0",1024);
  register_foreign_function((void*)&j1,"j1",1024);
  register_foreign_function((void*)&jn,"jn",1024);
  register_foreign_function((void*)&lgamma,"lgamma",1024);
  register_foreign_function((void*)&y0,"y0",1024);
  register_foreign_function((void*)&y1,"y1",1024);
  register_foreign_function((void*)&yn,"yn",1024);
  register_foreign_function((void*)&rint,"rint",1024);
  register_foreign_function((void*)&nextafter,"nextafter",1024);
  register_foreign_function((void*)&remainder,"remainder",1024);
  register_foreign_function((void*)&acosf,"acosf",1024);
  register_foreign_function((void*)&asinf,"asinf",1024);
  register_foreign_function((void*)&atanf,"atanf",1024);
  register_foreign_function((void*)&atan2f,"atan2f",1024);
  register_foreign_function((void*)&cosf,"cosf",1024);
  register_foreign_function((void*)&sinf,"sinf",1024);
  register_foreign_function((void*)&tanf,"tanf",1024);
  register_foreign_function((void*)&coshf,"coshf",1024);
  register_foreign_function((void*)&sinhf,"sinhf",1024);
  register_foreign_function((void*)&tanhf,"tanhf",1024);
  register_foreign_function((void*)&acoshf,"acoshf",1024);
  register_foreign_function((void*)&asinhf,"asinhf",1024);
  register_foreign_function((void*)&atanhf,"atanhf",1024);
  register_foreign_function((void*)&expf,"expf",1024);
  register_foreign_function((void*)&frexpf,"frexpf",1024);
  register_foreign_function((void*)&ldexpf,"ldexpf",1024);
  register_foreign_function((void*)&logf,"logf",1024);
  register_foreign_function((void*)&log10f,"log10f",1024);
  register_foreign_function((void*)&expm1f,"expm1f",1024);
  register_foreign_function((void*)&log1pf,"log1pf",1024);
  register_foreign_function((void*)&logbf,"logbf",1024);
  register_foreign_function((void*)&modff,"modff",1024);
  register_foreign_function((void*)&powf,"powf",1024);
  register_foreign_function((void*)&sqrtf,"sqrtf",1024);
  register_foreign_function((void*)&cbrtf,"cbrtf",1024);
  register_foreign_function((void*)&ceilf,"ceilf",1024);
  register_foreign_function((void*)&fabsf,"fabsf",1024);
  register_foreign_function((void*)&floorf,"floorf",1024);
  register_foreign_function((void*)&fmodf,"fmodf",1024);
  register_foreign_function((void*)&isinff,"isinff",1024);
  register_foreign_function((void*)&finitef,"finitef",1024);
  register_foreign_function((void*)&copysignf,"copysignf",1024);
  register_foreign_function((void*)&scalbnf,"scalbnf",1024);
  register_foreign_function((void*)&dremf,"dremf",1024);
  register_foreign_function((void*)&significandf,"significandf",1024);
  register_foreign_function((void*)&isnanf,"isnanf",1024);
  register_foreign_function((void*)&ilogbf,"ilogbf",1024);
  register_foreign_function((void*)&hypotf,"hypotf",1024);
  register_foreign_function((void*)&erff,"erff",1024);
  register_foreign_function((void*)&erfcf,"erfcf",1024);
  register_foreign_function((void*)&gammaf,"gammaf",1024);
  register_foreign_function((void*)&j0f,"j0f",1024);
  register_foreign_function((void*)&j1f,"j1f",1024);
  register_foreign_function((void*)&jnf,"jnf",1024);
  register_foreign_function((void*)&lgammaf,"lgammaf",1024);
  register_foreign_function((void*)&y0f,"y0f",1024);
  register_foreign_function((void*)&y1f,"y1f",1024);
  register_foreign_function((void*)&ynf,"ynf",1024);
  register_foreign_function((void*)&rintf,"rintf",1024);
  register_foreign_function((void*)&nextafterf,"nextafterf",1024);
  register_foreign_function((void*)&remainderf,"remainderf",1024);
  register_foreign_function((void*)&access,"access",1024);
# if defined(__USE_GNU)
  register_foreign_function((void*)&euidaccess,"euidaccess",1024);
# endif
  register_foreign_function((void*)&lseek,"lseek",1024);
  register_foreign_function((void*)&close,"close",1024);
  register_foreign_function((void*)&fd_read,"fd_read",1024);
  register_foreign_function((void*)&fd_write,"fd_write",1024);
  register_foreign_function((void*)&pipe,"pipe",1024);
  register_foreign_function((void*)&alarm,"alarm",1024);
  register_foreign_function((void*)&sleep,"sleep",1024);
  register_foreign_function((void*)&ualarm,"ualarm",1024);
  register_foreign_function((void*)&usleep,"usleep",1024);
  register_foreign_function((void*)&pause,"pause",1024);
  register_foreign_function((void*)&chown,"chown",1024);
  register_foreign_function((void*)&fchown,"fchown",1024);
  register_foreign_function((void*)&chdir,"chdir",1024);
  register_foreign_function((void*)&fchdir,"fchdir",1024);
# if defined(__USE_GNU)
  register_foreign_function((void*)&get_current_dir_name,"get_current_dir_name",1026);
# endif
  register_foreign_function((void*)&dup,"dup",1024);
  register_foreign_function((void*)&dup2,"dup2",1024);
  register_foreign_function((void*)&execv,"execv",1024);
  register_foreign_function((void*)&execve,"execve",1024);
  register_foreign_function((void*)&execvp,"execvp",1024);
  register_foreign_function((void*)&execl,"execl",1024);
  register_foreign_function((void*)&execlp,"execlp",1024);
  register_foreign_function((void*)&execle,"execle",1024);
  register_foreign_function((void*)&nice,"nice",1024);
  register_foreign_function((void*)&_exit,"_exit",1024);
  register_foreign_function((void*)&pathconf,"pathconf",1024);
  register_foreign_function((void*)&fpathconf,"fpathconf",1024);
  register_foreign_function((void*)&sysconf,"sysconf",1024);
  register_foreign_function((void*)&getpid,"getpid",1024);
  register_foreign_function((void*)&getppid,"getppid",1024);
  register_foreign_function((void*)&getpgrp,"getpgrp",1024);
  register_foreign_function((void*)&setpgid,"setpgid",1024);
  register_foreign_function((void*)&setsid,"setsid",1024);
  register_foreign_function((void*)&getuid,"getuid",1024);
  register_foreign_function((void*)&geteuid,"geteuid",1024);
  register_foreign_function((void*)&getgid,"getgid",1024);
  register_foreign_function((void*)&getegid,"getegid",1024);
# if defined(__USE_GNU)
  register_foreign_function((void*)&group_member,"group_member",1024);
# endif
  register_foreign_function((void*)&setuid,"setuid",1024);
  register_foreign_function((void*)&setreuid,"setreuid",1024);
  register_foreign_function((void*)&seteuid,"seteuid",1024);
  register_foreign_function((void*)&setgid,"setgid",1024);
  register_foreign_function((void*)&setregid,"setregid",1024);
  register_foreign_function((void*)&setegid,"setegid",1024);
  register_foreign_function((void*)&fork,"fork",1024);
  register_foreign_function((void*)&vfork,"vfork",1024);
  register_foreign_function((void*)&wait,"wait",1024);
  register_foreign_function((void*)&waitpid,"waitpid",1024);
  register_foreign_function((void*)&ttyname,"ttyname",1024);
  register_foreign_function((void*)&isatty,"isatty",1024);
  register_foreign_function((void*)&ttyslot,"ttyslot",1024);
  register_foreign_function((void*)&link,"link",1024);
  register_foreign_function((void*)&symlink,"symlink",1024);
  register_foreign_function((void*)&unlink,"unlink",1024);
  register_foreign_function((void*)&rmdir,"rmdir",1024);
  register_foreign_function((void*)&tcgetpgrp,"tcgetpgrp",1024);
  register_foreign_function((void*)&tcsetpgrp,"tcsetpgrp",1024);
  register_foreign_function((void*)&getlogin,"getlogin",1024);
  register_foreign_function((void*)&gethostname,"gethostname",1024);
  register_foreign_function((void*)&sethostname,"sethostname",1024);
  register_foreign_function((void*)&gethostid,"gethostid",1024);
  register_foreign_function((void*)&sethostid,"sethostid",1024);
  register_foreign_function((void*)&getdomainname,"getdomainname",1024);
  register_foreign_function((void*)&setdomainname,"setdomainname",1024);
  register_foreign_function((void*)&fsync,"fsync",1024);
  register_foreign_function((void*)&vhangup,"vhangup",1024);
  register_foreign_function((void*)&acct,"acct",1024);
  register_foreign_function((void*)&chroot,"chroot",1024);
  register_foreign_function((void*)&getusershell,"getusershell",1024);
  register_foreign_function((void*)&endusershell,"endusershell",1024);
  register_foreign_function((void*)&setusershell,"setusershell",1024);
  register_foreign_function((void*)&getpass,"getpass",1024);
  register_foreign_function((void*)&daemon,"daemon",1024);
  register_foreign_function((void*)&sync,"sync",1024);
  register_foreign_function((void*)&getpagesize,"getpagesize",1024);
  register_foreign_function((void*)&truncate,"truncate",1024);
  register_foreign_function((void*)&ftruncate,"ftruncate",1024);
  register_foreign_function((void*)&getdtablesize,"getdtablesize",1024);
  register_foreign_function((void*)&brk,"brk",1024);
  register_foreign_function((void*)&sbrk,"sbrk",1024);
  register_foreign_function((void*)&fdatasync,"fdatasync",1024);
  register_foreign_function((void*)&flock,"flock",1024);
  register_foreign_function((void*)&fcntl,"fcntl",1024);
  register_foreign_function((void*)&open,"open",1024);
  register_foreign_function((void*)&creat,"creat",1024);
  register_foreign_function((void*)&lockf,"lockf",1024);
  register_foreign_function((void*)&stat,"stat",1024);
  register_foreign_function((void*)&fstat,"fstat",1024);
  register_foreign_function((void*)&lstat,"lstat",1024);
  register_foreign_function((void*)&chmod,"chmod",1024);
  register_foreign_function((void*)&fchmod,"fchmod",1024);
  register_foreign_function((void*)&umask,"umask",1024);
  register_foreign_function((void*)&mkdir,"mkdir",1024);
  register_foreign_function((void*)&mknod,"mknod",1024);
  register_foreign_function((void*)&mkfifo,"mkfifo",1024);
  register_foreign_function((void*)&clearerr,"clearerr",1024);
  register_foreign_function((void*)&fclose,"fclose",1024);
  register_foreign_function((void*)&feof,"feof",1024);
  register_foreign_function((void*)&ferror,"ferror",1024);
  register_foreign_function((void*)&fflush,"fflush",1024);
  register_foreign_function((void*)&fgetc,"fgetc",1024);
  register_foreign_function((void*)&fgetpos,"fgetpos",1024);
  register_foreign_function((void*)&fopen,"fopen",1024);
  register_foreign_function((void*)&fprintf,"fprintf",1024);
  register_foreign_function((void*)&fputc,"fputc",1024);
  register_foreign_function((void*)&fputs,"fputs",1024);
  register_foreign_function((void*)&fscanf,"fscanf",1024);
  register_foreign_function((void*)&fseek,"fseek",1024);
  register_foreign_function((void*)&fsetpos,"fsetpos",1024);
  register_foreign_function((void*)&ftell,"ftell",1024);
  register_foreign_function((void*)&getc,"getc",1024);
  register_foreign_function((void*)&getchar,"getchar",1024);
  register_foreign_function((void*)&perror,"perror",1024);
  register_foreign_function((void*)&printf,"printf",1024);
  register_foreign_function((void*)&putc,"putc",1024);
  register_foreign_function((void*)&putchar,"putchar",1024);
  register_foreign_function((void*)&puts,"puts",1024);
  register_foreign_function((void*)&remove,"remove",1024);
  register_foreign_function((void*)&rename,"rename",1024);
  register_foreign_function((void*)&rewind,"rewind",1024);
  register_foreign_function((void*)&scanf,"scanf",1024);
  register_foreign_function((void*)&setbuf,"setbuf",1024);
  register_foreign_function((void*)&setlinebuf,"setlinebuf",1024);
  register_foreign_function((void*)&setbuffer,"setbuffer",1024);
  register_foreign_function((void*)&setvbuf,"setvbuf",1024);
  register_foreign_function((void*)&sscanf,"sscanf",1024);
  register_foreign_function((void*)&tmpfile,"tmpfile",1024);
  register_foreign_function((void*)&tmpnam,"tmpnam",1024);
  register_foreign_function((void*)&tmpnam_r,"tmpnam_r",1024);
  register_foreign_function((void*)&tempnam,"tempnam",1026);
  register_foreign_function((void*)&ungetc,"ungetc",1024);
# if defined(__USE_GNU)
  register_foreign_function((void*)&fcloseall,"fcloseall",1024);
# endif
  register_foreign_function((void*)&fdopen,"fdopen",1024);
  register_foreign_function((void*)&fileno,"fileno",1024);
  register_foreign_function((void*)&popen,"popen",1024);
  register_foreign_function((void*)&pclose,"pclose",1024);
  register_foreign_function((void*)&ctermid,"ctermid",1024);
  register_foreign_function((void*)&opendir,"opendir",1024);
  register_foreign_function((void*)&closedir,"closedir",1024);
  register_foreign_function((void*)&readdir,"readdir",1024);
  register_foreign_function((void*)&readdir64,"readdir64",1024);
  register_foreign_function((void*)&readdir_r,"readdir_r",1024);
  register_foreign_function((void*)&readdir64_r,"readdir64_r",1024);
  register_foreign_function((void*)&rewinddir,"rewinddir",1024);
  register_foreign_function((void*)&dirfd,"dirfd",1024);
  register_foreign_function((void*)&seekdir,"seekdir",1024);
  register_foreign_function((void*)&telldir,"telldir",1024);
  register_foreign_function((void*)&scandir,"scandir",1024);
  register_foreign_function((void*)&scandir64,"scandir64",1024);
  register_foreign_function((void*)&alphasort,"alphasort",1024);
  register_foreign_function((void*)&alphasort64,"alphasort64",1024);
  register_foreign_function((void*)&versionsort,"versionsort",1024);
  register_foreign_function((void*)&versionsort64,"versionsort64",1024);
  register_foreign_function((void*)&setpwent,"setpwent",1024);
  register_foreign_function((void*)&endpwent,"endpwent",1024);
  register_foreign_function((void*)&getpwent,"getpwent",1024);
  register_foreign_function((void*)&fgetpwent,"fgetpwent",1024);
  register_foreign_function((void*)&putpwent,"putpwent",1024);
  register_foreign_function((void*)&getpwuid,"getpwuid",1024);
  register_foreign_function((void*)&getpwnam,"getpwnam",1024);
  register_foreign_function((void*)&setgrent,"setgrent",1024);
  register_foreign_function((void*)&endgrent,"endgrent",1024);
  register_foreign_function((void*)&getgrent,"getgrent",1024);
  register_foreign_function((void*)&fgetgrent,"fgetgrent",1024);
  register_foreign_function((void*)&getgrgid,"getgrgid",1024);
  register_foreign_function((void*)&getgrnam,"getgrnam",1024);
  register_foreign_function((void*)&setgroups,"setgroups",1024);
  register_foreign_function((void*)&initgroups,"initgroups",1024);
  register_foreign_function((void*)&uname,"uname",1024);
  register_foreign_function((void*)&cfgetospeed,"cfgetospeed",1024);
  register_foreign_function((void*)&cfgetispeed,"cfgetispeed",1024);
  register_foreign_function((void*)&cfsetospeed,"cfsetospeed",1024);
  register_foreign_function((void*)&cfsetispeed,"cfsetispeed",1024);
  register_foreign_function((void*)&cfsetspeed,"cfsetspeed",1024);
  register_foreign_function((void*)&tcgetattr,"tcgetattr",1024);
  register_foreign_function((void*)&tcsetattr,"tcsetattr",1024);
  register_foreign_function((void*)&cfmakeraw,"cfmakeraw",1024);
  register_foreign_function((void*)&tcsendbreak,"tcsendbreak",1024);
  register_foreign_function((void*)&tcdrain,"tcdrain",1024);
  register_foreign_function((void*)&tcflush,"tcflush",1024);
  register_foreign_function((void*)&tcflow,"tcflow",1024);
  register_foreign_function((void*)&strerror,"strerror",1024);
  register_foreign_function((void*)&strsignal,"strsignal",1024);
  register_foreign_function((void*)&ioctl,"ioctl",1024);
  register_foreign_function((void*)&sigemptyset,"sigemptyset",1024);
  register_foreign_function((void*)&sigfillset,"sigfillset",1024);
  register_foreign_function((void*)&sigaddset,"sigaddset",1024);
  register_foreign_function((void*)&sigdelset,"sigdelset",1024);
  register_foreign_function((void*)&sigismember,"sigismember",1024);
  register_foreign_function((void*)&sigprocmask,"sigprocmask",1024);
  register_foreign_function((void*)&sigpending,"sigpending",1024);
  register_foreign_function((void*)&sigsuspend,"sigsuspend",1024);
  register_foreign_function((void*)&sigaction,"sigaction",1024);
  register_foreign_function((void*)&kill,"kill",1024);
  register_foreign_function((void*)&raise,"raise",1024);
  register_foreign_function((void*)&sigpause,"sigpause",1024);
  register_foreign_function((void*)&killpg,"killpg",1024);
  register_foreign_function((void*)&MODULE__LINUX__CONSTANT_MAP_LONG,"MODULE__LINUX__CONSTANT_MAP_LONG",1024);
}

void module__linux__fini_function (module_t* module)
{
  (void)module; /* avoid -Wunused-parameter */

}
