#include "clisp.h"

extern gcv_object_t module__libsvm__object_tab[];
#include "config.h"
#include <svm.h>

void (libsvm_print_string) (char* g2989);
void (libsvm_print_string) (char* g2989)
{
  begin_callback();
  pushSTACK(g2989 == NULL ? NIL : asciz_to_string(g2989,GLO(foreign_encoding)));
  funcall(module__libsvm__object_tab[0],1);
  end_callback();
}

#if !defined(HAVE_SVM_DESTROY_MODEL)
# if defined(HAVE_SVM_FREE_AND_DESTROY_MODEL)
void svm_destroy_model (struct svm_model *model){ svm_free_and_destroy_model(&model); }
# else
#  error No svm_destroy_model and no svm_free_and_destroy_model!
# endif
#endif

subr_t module__libsvm__subr_tab[1];
uintC module__libsvm__subr_tab_size = 0;
subr_initdata_t module__libsvm__subr_tab_initdata[1];

gcv_object_t module__libsvm__object_tab[1];
object_initdata_t module__libsvm__object_tab_initdata[1] = {
  { "|LIBSVM|::|write-string-to-libsvm-output|" },
};
uintC module__libsvm__object_tab_size = 1;


void module__libsvm__init_function_1 (module_t* module);
void module__libsvm__init_function_2 (module_t* module);
void module__libsvm__fini_function (module_t* module);

void module__libsvm__init_function_1 (module_t* module)
{
  (void)module; /* avoid -Wunused-parameter */

}

void module__libsvm__init_function_2 (module_t* module)
{
  (void)module; /* avoid -Wunused-parameter */

  
 #if defined(HAVE_SVM_SET_PRINT_STRING_FUNCTION)
  svm_set_print_string_function((void (*) (const char*))&libsvm_print_string);
 #else
  svm_print_string = (void (*) (const char*))&libsvm_print_string;
 #endif

  register_foreign_variable((void*)&libsvm_version,"libsvm_version",0,sizeof(libsvm_version));
  register_foreign_function((void*)&svm_destroy_model,"svm_destroy_model",1024);
  register_foreign_function((void*)&svm_check_parameter,"svm_check_parameter",1024);
  register_foreign_function((void*)&svm_train,"svm_train",1024);
  register_foreign_function((void*)&svm_cross_validation,"svm_cross_validation",1024);
  register_foreign_function((void*)&svm_save_model,"svm_save_model",1024);
  register_foreign_function((void*)&svm_load_model,"svm_load_model",1024);
  register_foreign_function((void*)&svm_get_svm_type,"svm_get_svm_type",1024);
  register_foreign_function((void*)&svm_get_nr_class,"svm_get_nr_class",1024);
  register_foreign_function((void*)&svm_get_labels,"svm_get_labels",1024);
  register_foreign_function((void*)&svm_get_svr_probability,"svm_get_svr_probability",1024);
  register_foreign_function((void*)&svm_predict_values,"svm_predict_values",1024);
  register_foreign_function((void*)&svm_predict,"svm_predict",1024);
  register_foreign_function((void*)&svm_predict_probability,"svm_predict_probability",1024);
  register_foreign_function((void*)&svm_check_probability_model,"svm_check_probability_model",1024);
}

void module__libsvm__fini_function (module_t* module)
{
  (void)module; /* avoid -Wunused-parameter */

}
