#include "clisp.h"

extern gcv_object_t module__pari__object_tab[];
#undef T
#include <pari/pari.h>
#include <pari/paripriv.h>
char* get_entry_doc (char* s) { entree *e = is_entry(s); return e==NULL?NULL:(char*)e->help; }
#include "cpari.h"

void get_integer_data (GEN x, ulong len, ulong *data)
{ ulong i; for (i=0; i < len; i++) data[len-i-1] = *int_W(x,i); }
void set_integer_data (GEN x, ulong len, ulong *data) {
  /* 1st data element is the header, skip it */
  ulong i; len--; data++;
  for (i=0; i < len; i++) *int_W(x,i) = data[len-i-1];
}

subr_t module__pari__subr_tab[1];
uintC module__pari__subr_tab_size = 0;
subr_initdata_t module__pari__subr_tab_initdata[1];

gcv_object_t module__pari__object_tab[1];
object_initdata_t module__pari__object_tab_initdata[1];
uintC module__pari__object_tab_size = 0;

const char* MODULE__PARI__CONSTANT_MAP_C_STRING (int number, int *definedp);
const char* MODULE__PARI__CONSTANT_MAP_C_STRING (int number, int *definedp) {
  *definedp=1;
  switch (number) {
# if defined(PARIVERSION)
    case 0: return PARIVERSION;
# endif
# if defined(PARIINFO)
    case 1: return PARIINFO;
# endif
    default: *definedp=0; return 0;
  }
}
long MODULE__PARI__CONSTANT_MAP_LONG (int number, int *definedp);
long MODULE__PARI__CONSTANT_MAP_LONG (int number, int *definedp) {
  *definedp=1;
  switch (number) {
# if defined(MAXVARN)
    case 0: return MAXVARN;
# endif
# if defined(PARI_VERSION_CODE)
    case 1: return PARI_VERSION_CODE;
# endif
# if defined(PARI_VERSION_SHIFT)
    case 2: return PARI_VERSION_SHIFT;
# endif
    default: *definedp=0; return 0;
  }
}
unsigned long MODULE__PARI__CONSTANT_MAP_ULONG (int number, int *definedp);
unsigned long MODULE__PARI__CONSTANT_MAP_ULONG (int number, int *definedp) {
  *definedp=1;
  switch (number) {
# if defined(SIGNBITS)
    case 0: return SIGNBITS;
# endif
# if defined(SIGNSHIFT)
    case 1: return SIGNSHIFT;
# endif
# if defined(TYPBITS)
    case 2: return TYPBITS;
# endif
# if defined(TYPSHIFT)
    case 3: return TYPSHIFT;
# endif
# if defined(LGBITS)
    case 4: return LGBITS;
# endif
# if defined(EXPOBITS)
    case 5: return EXPOBITS;
# endif
# if defined(HIGHEXPOBIT)
    case 6: return HIGHEXPOBIT;
# endif
# if defined(VALPBITS)
    case 7: return VALPBITS;
# endif
# if defined(HIGHVALPBIT)
    case 8: return HIGHVALPBIT;
# endif
# if defined(PRECPBITS)
    case 9: return PRECPBITS;
# endif
# if defined(PRECPSHIFT)
    case 10: return PRECPSHIFT;
# endif
# if defined(VARNBITS)
    case 11: return VARNBITS;
# endif
# if defined(VARNSHIFT)
    case 12: return VARNSHIFT;
# endif
# if defined(CLONEBIT)
    case 13: return CLONEBIT;
# endif
    default: *definedp=0; return 0;
  }
}

void module__pari__init_function_1 (module_t* module);
void module__pari__init_function_2 (module_t* module);
void module__pari__fini_function (module_t* module);

void module__pari__init_function_1 (module_t* module)
{
  (void)module; /* avoid -Wunused-parameter */

}

void module__pari__init_function_2 (module_t* module)
{
  (void)module; /* avoid -Wunused-parameter */

  
init_for_clisp(8000000,500000);

  register_foreign_variable((void*)&pari_mainstack,"pari_mainstack",0,sizeof(pari_mainstack));
  register_foreign_variable((void*)&precdl,"precdl",0,sizeof(precdl));
  register_foreign_variable((void*)&avma,"avma",0,sizeof(avma));
  register_foreign_variable((void*)&bernzone,"bernzone",1,sizeof(bernzone));
  register_foreign_variable((void*)&gen_1,"gen_1",1,sizeof(gen_1));
  register_foreign_variable((void*)&gen_2,"gen_2",1,sizeof(gen_2));
  register_foreign_variable((void*)&ghalf,"ghalf",1,sizeof(ghalf));
  register_foreign_variable((void*)&gen_0,"gen_0",1,sizeof(gen_0));
  register_foreign_variable((void*)&gen_m1,"gen_m1",1,sizeof(gen_m1));
  register_foreign_variable((void*)&gen_m2,"gen_m2",1,sizeof(gen_m2));
  register_foreign_variable((void*)&gnil,"gnil",1,sizeof(gnil));
  register_foreign_variable((void*)&primetab,"primetab",1,sizeof(primetab));
  register_foreign_variable((void*)&diffptr,"diffptr",1,sizeof(diffptr));
  register_foreign_variable((void*)&new_galois_format,"new_galois_format",0,sizeof(new_galois_format));
  register_foreign_variable((void*)&factor_add_primes,"factor_add_primes",0,sizeof(factor_add_primes));
  register_foreign_variable((void*)&DEBUGFILES,"DEBUGFILES",0,sizeof(DEBUGFILES));
  register_foreign_variable((void*)&DEBUGLEVEL,"DEBUGLEVEL",0,sizeof(DEBUGLEVEL));
  register_foreign_variable((void*)&DEBUGMEM,"DEBUGMEM",0,sizeof(DEBUGMEM));
  register_foreign_function((void*)&gerepile,"gerepile",1024);
  register_foreign_function((void*)&is_entry,"is_entry",1024);
  register_foreign_function((void*)&get_entry_doc,"get_entry_doc",1024);
  register_foreign_function((void*)&paristack_newrsize,"paristack_newrsize",1024);
  register_foreign_function((void*)&paristack_resize,"paristack_resize",1024);
  register_foreign_function((void*)&paristack_setsize,"paristack_setsize",1024);
  register_foreign_function((void*)&parivstack_resize,"parivstack_resize",1024);
  register_foreign_function((void*)&parivstack_reset,"parivstack_reset",1024);
  register_foreign_function((void*)&init_for_clisp,"init_for_clisp",1024);
  register_foreign_function((void*)&pari_close,"pari_close",1024);
  register_foreign_function((void*)&maxprime,"maxprime",1024);
  register_foreign_function((void*)&gp_read_str,"gp_read_str",1024);
  register_foreign_function((void*)&GENtostr,"GENtostr",1026);
  register_foreign_function((void*)&GENtostr_raw,"GENtostr_raw",1024);
  register_foreign_function((void*)&GENtoTeXstr,"GENtoTeXstr",1026);
  register_foreign_function((void*)&variables_vecsmall,"variables_vecsmall",1024);
  register_foreign_function((void*)&gvar,"gvar",1024);
  register_foreign_function((void*)&is_bigint,"is_bigint",1024);
  register_foreign_function((void*)&get_integer_data,"get_integer_data",1024);
  register_foreign_function((void*)&set_integer_data,"set_integer_data",1024);
  register_foreign_function((void*)&cgetg,"cgetg",1024);
  register_foreign_function((void*)&mkmoo,"mkmoo",1024);
  register_foreign_function((void*)&mkoo,"mkoo",1024);
  register_foreign_function((void*)&inf_get_sign,"inf_get_sign",1024);
  register_foreign_function((void*)&gnot,"gnot",1024);
  register_foreign_function((void*)&glength,"glength",1024);
  register_foreign_function((void*)&pari_get_hist,"pari_get_hist",1024);
  register_foreign_function((void*)&pari_get_histtime,"pari_get_histtime",1024);
  register_foreign_function((void*)&gneg,"gneg",1024);
  register_foreign_function((void*)&mpcatalan,"mpcatalan",1024);
  register_foreign_function((void*)&gtocol0,"gtocol0",1024);
  register_foreign_function((void*)&gtocolrev0,"gtocolrev0",1024);
  register_foreign_function((void*)&mpeuler,"mpeuler",1024);
  register_foreign_function((void*)&gen_I,"gen_I",1024);
  register_foreign_function((void*)&gtolist,"gtolist",1024);
  register_foreign_function((void*)&gtomap,"gtomap",1024);
  register_foreign_function((void*)&gtomat,"gtomat",1024);
  register_foreign_function((void*)&gmodulo,"gmodulo",1024);
  register_foreign_function((void*)&ggrando,"ggrando",1024);
  register_foreign_function((void*)&mppi,"mppi",1024);
  register_foreign_function((void*)&gtopoly,"gtopoly",1024);
  register_foreign_function((void*)&gtopolyrev,"gtopolyrev",1024);
  register_foreign_function((void*)&Qfb0,"Qfb0",1024);
  register_foreign_function((void*)&Ser0,"Ser0",1024);
  register_foreign_function((void*)&gtoset,"gtoset",1024);
  register_foreign_function((void*)&Str,"Str",1024);
  register_foreign_function((void*)&Strchr,"Strchr",1024);
  register_foreign_function((void*)&Strexpand,"Strexpand",1024);
  register_foreign_function((void*)&Strprintf,"Strprintf",1024);
  register_foreign_function((void*)&Strtex,"Strtex",1024);
  register_foreign_function((void*)&gtovec0,"gtovec0",1024);
  register_foreign_function((void*)&gtovecrev0,"gtovecrev0",1024);
  register_foreign_function((void*)&gtovecsmall0,"gtovecsmall0",1024);
  register_foreign_function((void*)&mpfact,"mpfact",1024);
  register_foreign_function((void*)&gne,"gne",1024);
  register_foreign_function((void*)&gmode,"gmode",1024);
  register_foreign_function((void*)&gmod,"gmod",1024);
  register_foreign_function((void*)&andpari,"andpari",1024);
  register_foreign_function((void*)&deriv,"deriv",1024);
  register_foreign_function((void*)&gmule,"gmule",1024);
  register_foreign_function((void*)&gmul,"gmul",1024);
  register_foreign_function((void*)&gadd1e,"gadd1e",1024);
  register_foreign_function((void*)&gadde,"gadde",1024);
  register_foreign_function((void*)&gadd,"gadd",1024);
  register_foreign_function((void*)&gsub1e,"gsub1e",1024);
  register_foreign_function((void*)&gsube,"gsube",1024);
  register_foreign_function((void*)&gsub,"gsub",1024);
  register_foreign_function((void*)&member_a1,"member_a1",1024);
  register_foreign_function((void*)&member_a2,"member_a2",1024);
  register_foreign_function((void*)&member_a3,"member_a3",1024);
  register_foreign_function((void*)&member_a4,"member_a4",1024);
  register_foreign_function((void*)&member_a6,"member_a6",1024);
  register_foreign_function((void*)&member_area,"member_area",1024);
  register_foreign_function((void*)&member_b2,"member_b2",1024);
  register_foreign_function((void*)&member_b4,"member_b4",1024);
  register_foreign_function((void*)&member_b6,"member_b6",1024);
  register_foreign_function((void*)&member_b8,"member_b8",1024);
  register_foreign_function((void*)&member_bid,"member_bid",1024);
  register_foreign_function((void*)&member_bnf,"member_bnf",1024);
  register_foreign_function((void*)&member_c4,"member_c4",1024);
  register_foreign_function((void*)&member_c6,"member_c6",1024);
  register_foreign_function((void*)&member_clgp,"member_clgp",1024);
  register_foreign_function((void*)&member_codiff,"member_codiff",1024);
  register_foreign_function((void*)&member_cyc,"member_cyc",1024);
  register_foreign_function((void*)&member_diff,"member_diff",1024);
  register_foreign_function((void*)&member_disc,"member_disc",1024);
  register_foreign_function((void*)&member_e,"member_e",1024);
  register_foreign_function((void*)&member_eta,"member_eta",1024);
  register_foreign_function((void*)&member_f,"member_f",1024);
  register_foreign_function((void*)&member_fu,"member_fu",1024);
  register_foreign_function((void*)&member_futu,"member_futu",1024);
  register_foreign_function((void*)&member_gen,"member_gen",1024);
  register_foreign_function((void*)&member_group,"member_group",1024);
  register_foreign_function((void*)&member_index,"member_index",1024);
  register_foreign_function((void*)&member_j,"member_j",1024);
  register_foreign_function((void*)&member_mod,"member_mod",1024);
  register_foreign_function((void*)&member_nf,"member_nf",1024);
  register_foreign_function((void*)&member_no,"member_no",1024);
  register_foreign_function((void*)&member_omega,"member_omega",1024);
  register_foreign_function((void*)&member_orders,"member_orders",1024);
  register_foreign_function((void*)&member_p,"member_p",1024);
  register_foreign_function((void*)&member_pol,"member_pol",1024);
  register_foreign_function((void*)&member_polabs,"member_polabs",1024);
  register_foreign_function((void*)&member_r1,"member_r1",1024);
  register_foreign_function((void*)&member_r2,"member_r2",1024);
  register_foreign_function((void*)&member_reg,"member_reg",1024);
  register_foreign_function((void*)&member_roots,"member_roots",1024);
  register_foreign_function((void*)&member_sign,"member_sign",1024);
  register_foreign_function((void*)&member_t2,"member_t2",1024);
  register_foreign_function((void*)&member_tate,"member_tate",1024);
  register_foreign_function((void*)&member_tu,"member_tu",1024);
  register_foreign_function((void*)&member_tufu,"member_tufu",1024);
  register_foreign_function((void*)&member_zk,"member_zk",1024);
  register_foreign_function((void*)&member_zkst,"member_zkst",1024);
  register_foreign_function((void*)&gdive,"gdive",1024);
  register_foreign_function((void*)&gdiv,"gdiv",1024);
  register_foreign_function((void*)&gshiftle,"gshiftle",1024);
  register_foreign_function((void*)&gshift,"gshift",1024);
  register_foreign_function((void*)&gle,"gle",1024);
  register_foreign_function((void*)&glt,"glt",1024);
  register_foreign_function((void*)&gidentical,"gidentical",1024);
  register_foreign_function((void*)&geq,"geq",1024);
  register_foreign_function((void*)&gge,"gge",1024);
  register_foreign_function((void*)&gshiftre,"gshiftre",1024);
  register_foreign_function((void*)&gshift_right,"gshift_right",1024);
  register_foreign_function((void*)&ggt,"ggt",1024);
  register_foreign_function((void*)&matslice0,"matslice0",1024);
  register_foreign_function((void*)&vecslice0,"vecslice0",1024);
  register_foreign_function((void*)&gdivrounde,"gdivrounde",1024);
  register_foreign_function((void*)&gdivround,"gdivround",1024);
  register_foreign_function((void*)&gdivente,"gdivente",1024);
  register_foreign_function((void*)&gdivent,"gdivent",1024);
  register_foreign_function((void*)&gpow,"gpow",1024);
  register_foreign_function((void*)&orpari,"orpari",1024);
  register_foreign_function((void*)&gtrans,"gtrans",1024);
  register_foreign_function((void*)&gabs,"gabs",1024);
  register_foreign_function((void*)&gacos,"gacos",1024);
  register_foreign_function((void*)&gacosh,"gacosh",1024);
  register_foreign_function((void*)&addhelp,"addhelp",1024);
  register_foreign_function((void*)&addprimes,"addprimes",1024);
  register_foreign_function((void*)&agm,"agm",1024);
  register_foreign_function((void*)&gp_alarm,"gp_alarm",1024);
  register_foreign_function((void*)&algadd,"algadd",1024);
  register_foreign_function((void*)&algalgtobasis,"algalgtobasis",1024);
  register_foreign_function((void*)&algaut,"algaut",1024);
  register_foreign_function((void*)&algb,"algb",1024);
  register_foreign_function((void*)&algbasis,"algbasis",1024);
  register_foreign_function((void*)&algbasistoalg,"algbasistoalg",1024);
  register_foreign_function((void*)&algcenter,"algcenter",1024);
  register_foreign_function((void*)&alg_centralproj,"alg_centralproj",1024);
  register_foreign_function((void*)&algchar,"algchar",1024);
  register_foreign_function((void*)&algcharpoly,"algcharpoly",1024);
  register_foreign_function((void*)&algdegree,"algdegree",1024);
  register_foreign_function((void*)&algdep0,"algdep0",1024);
  register_foreign_function((void*)&algdim,"algdim",1024);
  register_foreign_function((void*)&algdisc,"algdisc",1024);
  register_foreign_function((void*)&algdivl,"algdivl",1024);
  register_foreign_function((void*)&algdivr,"algdivr",1024);
  register_foreign_function((void*)&alggroup,"alggroup",1024);
  register_foreign_function((void*)&alggroupcenter,"alggroupcenter",1024);
  register_foreign_function((void*)&alghasse,"alghasse",1024);
  register_foreign_function((void*)&alghassef,"alghassef",1024);
  register_foreign_function((void*)&alghassei,"alghassei",1024);
  register_foreign_function((void*)&algindex,"algindex",1024);
  register_foreign_function((void*)&alginit,"alginit",1024);
  register_foreign_function((void*)&alginv,"alginv",1024);
  register_foreign_function((void*)&alginvbasis,"alginvbasis",1024);
  register_foreign_function((void*)&algisassociative,"algisassociative",1024);
  register_foreign_function((void*)&algiscommutative,"algiscommutative",1024);
  register_foreign_function((void*)&algisdivision,"algisdivision",1024);
  register_foreign_function((void*)&algisdivl,"algisdivl",1024);
  register_foreign_function((void*)&algisinv,"algisinv",1024);
  register_foreign_function((void*)&algisramified,"algisramified",1024);
  register_foreign_function((void*)&algissemisimple,"algissemisimple",1024);
  register_foreign_function((void*)&algissimple,"algissimple",1024);
  register_foreign_function((void*)&algissplit,"algissplit",1024);
  register_foreign_function((void*)&alglatadd,"alglatadd",1024);
  register_foreign_function((void*)&alglatcontains,"alglatcontains",1024);
  register_foreign_function((void*)&alglatelement,"alglatelement",1024);
  register_foreign_function((void*)&alglathnf,"alglathnf",1024);
  register_foreign_function((void*)&alglatindex,"alglatindex",1024);
  register_foreign_function((void*)&alglatinter,"alglatinter",1024);
  register_foreign_function((void*)&alglatlefttransporter,"alglatlefttransporter",1024);
  register_foreign_function((void*)&alglatmul,"alglatmul",1024);
  register_foreign_function((void*)&alglatrighttransporter,"alglatrighttransporter",1024);
  register_foreign_function((void*)&alglatsubset,"alglatsubset",1024);
  register_foreign_function((void*)&algmakeintegral,"algmakeintegral",1024);
  register_foreign_function((void*)&algmul,"algmul",1024);
  register_foreign_function((void*)&algmultable,"algmultable",1024);
  register_foreign_function((void*)&algneg,"algneg",1024);
  register_foreign_function((void*)&algnorm,"algnorm",1024);
  register_foreign_function((void*)&algpoleval,"algpoleval",1024);
  register_foreign_function((void*)&algpow,"algpow",1024);
  register_foreign_function((void*)&algprimesubalg,"algprimesubalg",1024);
  register_foreign_function((void*)&alg_quotient,"alg_quotient",1024);
  register_foreign_function((void*)&algradical,"algradical",1024);
  register_foreign_function((void*)&algramifiedplaces,"algramifiedplaces",1024);
  register_foreign_function((void*)&algrandom,"algrandom",1024);
  register_foreign_function((void*)&algrelmultable,"algrelmultable",1024);
  register_foreign_function((void*)&algsimpledec,"algsimpledec",1024);
  register_foreign_function((void*)&algsplit,"algsplit",1024);
  register_foreign_function((void*)&algsplittingdata,"algsplittingdata",1024);
  register_foreign_function((void*)&algsplittingfield,"algsplittingfield",1024);
  register_foreign_function((void*)&algsqr,"algsqr",1024);
  register_foreign_function((void*)&algsub,"algsub",1024);
  register_foreign_function((void*)&algsubalg,"algsubalg",1024);
  register_foreign_function((void*)&algtableinit,"algtableinit",1024);
  register_foreign_function((void*)&algtensor,"algtensor",1024);
  register_foreign_function((void*)&algtomatrix,"algtomatrix",1024);
  register_foreign_function((void*)&algtrace,"algtrace",1024);
  register_foreign_function((void*)&algtype,"algtype",1024);
  register_foreign_function((void*)&alias0,"alias0",1024);
  register_foreign_function((void*)&gp_allocatemem,"gp_allocatemem",1024);
  register_foreign_function((void*)&garg,"garg",1024);
  register_foreign_function((void*)&gasin,"gasin",1024);
  register_foreign_function((void*)&gasinh,"gasinh",1024);
  register_foreign_function((void*)&gatan,"gatan",1024);
  register_foreign_function((void*)&gatanh,"gatanh",1024);
  register_foreign_function((void*)&bernfrac,"bernfrac",1024);
  register_foreign_function((void*)&bernpol,"bernpol",1024);
  register_foreign_function((void*)&bernreal,"bernreal",1024);
  register_foreign_function((void*)&hbessel1,"hbessel1",1024);
  register_foreign_function((void*)&hbessel2,"hbessel2",1024);
  register_foreign_function((void*)&ibessel,"ibessel",1024);
  register_foreign_function((void*)&jbessel,"jbessel",1024);
  register_foreign_function((void*)&jbesselh,"jbesselh",1024);
  register_foreign_function((void*)&kbessel,"kbessel",1024);
  register_foreign_function((void*)&nbessel,"nbessel",1024);
  register_foreign_function((void*)&bestappr,"bestappr",1024);
  register_foreign_function((void*)&bestapprPade,"bestapprPade",1024);
  register_foreign_function((void*)&bestapprnf,"bestapprnf",1024);
  register_foreign_function((void*)&bigomega,"bigomega",1024);
  register_foreign_function((void*)&binaire,"binaire",1024);
  register_foreign_function((void*)&binomial0,"binomial0",1024);
  register_foreign_function((void*)&gbitand,"gbitand",1024);
  register_foreign_function((void*)&gbitneg,"gbitneg",1024);
  register_foreign_function((void*)&gbitnegimply,"gbitnegimply",1024);
  register_foreign_function((void*)&gbitor,"gbitor",1024);
  register_foreign_function((void*)&bitprecision0,"bitprecision0",1024);
  register_foreign_function((void*)&gbittest,"gbittest",1024);
  register_foreign_function((void*)&gbitxor,"gbitxor",1024);
  register_foreign_function((void*)&bnfcertify0,"bnfcertify0",1024);
  register_foreign_function((void*)&bnfcompress,"bnfcompress",1024);
  register_foreign_function((void*)&decodemodule,"decodemodule",1024);
  register_foreign_function((void*)&bnfinit0,"bnfinit0",1024);
  register_foreign_function((void*)&bnfisintnorm,"bnfisintnorm",1024);
  register_foreign_function((void*)&bnfisnorm,"bnfisnorm",1024);
  register_foreign_function((void*)&bnfisprincipal0,"bnfisprincipal0",1024);
  register_foreign_function((void*)&bnfissunit,"bnfissunit",1024);
  register_foreign_function((void*)&bnfisunit,"bnfisunit",1024);
  register_foreign_function((void*)&bnflog,"bnflog",1024);
  register_foreign_function((void*)&bnflogdegree,"bnflogdegree",1024);
  register_foreign_function((void*)&bnflogef,"bnflogef",1024);
  register_foreign_function((void*)&bnfnarrow,"bnfnarrow",1024);
  register_foreign_function((void*)&signunits,"signunits",1024);
  register_foreign_function((void*)&bnfsunit,"bnfsunit",1024);
  register_foreign_function((void*)&bnrL1,"bnrL1",1024);
  register_foreign_function((void*)&bnrchar,"bnrchar",1024);
  register_foreign_function((void*)&bnrclassno0,"bnrclassno0",1024);
  register_foreign_function((void*)&bnrclassnolist,"bnrclassnolist",1024);
  register_foreign_function((void*)&bnrconductor0,"bnrconductor0",1024);
  register_foreign_function((void*)&bnrdisc0,"bnrdisc0",1024);
  register_foreign_function((void*)&bnrdisclist0,"bnrdisclist0",1024);
  register_foreign_function((void*)&bnrgaloisapply,"bnrgaloisapply",1024);
  register_foreign_function((void*)&bnrgaloismatrix,"bnrgaloismatrix",1024);
  register_foreign_function((void*)&bnrinit0,"bnrinit0",1024);
  register_foreign_function((void*)&bnrisconductor0,"bnrisconductor0",1024);
  register_foreign_function((void*)&bnrisgalois,"bnrisgalois",1024);
  register_foreign_function((void*)&bnrisprincipal,"bnrisprincipal",1024);
  register_foreign_function((void*)&bnrrootnumber,"bnrrootnumber",1024);
  register_foreign_function((void*)&bnrstark,"bnrstark",1024);
  register_foreign_function((void*)&call0,"call0",1024);
  register_foreign_function((void*)&gceil,"gceil",1024);
  register_foreign_function((void*)&centerlift0,"centerlift0",1024);
  register_foreign_function((void*)&characteristic,"characteristic",1024);
  register_foreign_function((void*)&charconj0,"charconj0",1024);
  register_foreign_function((void*)&chardiv0,"chardiv0",1024);
  register_foreign_function((void*)&chareval,"chareval",1024);
  register_foreign_function((void*)&chargalois,"chargalois",1024);
  register_foreign_function((void*)&charker0,"charker0",1024);
  register_foreign_function((void*)&charmul0,"charmul0",1024);
  register_foreign_function((void*)&charorder0,"charorder0",1024);
  register_foreign_function((void*)&charpoly0,"charpoly0",1024);
  register_foreign_function((void*)&charpow0,"charpow0",1024);
  register_foreign_function((void*)&chinese,"chinese",1024);
  register_foreign_function((void*)&cmp_universal,"cmp_universal",1024);
  register_foreign_function((void*)&compo,"compo",1024);
  register_foreign_function((void*)&gconcat,"gconcat",1024);
  register_foreign_function((void*)&gconj,"gconj",1024);
  register_foreign_function((void*)&conjvec,"conjvec",1024);
  register_foreign_function((void*)&content0,"content0",1024);
  register_foreign_function((void*)&contfrac0,"contfrac0",1024);
  register_foreign_function((void*)&contfracpnqn,"contfracpnqn",1024);
  register_foreign_function((void*)&core0,"core0",1024);
  register_foreign_function((void*)&coredisc0,"coredisc0",1024);
  register_foreign_function((void*)&gcos,"gcos",1024);
  register_foreign_function((void*)&gcosh,"gcosh",1024);
  register_foreign_function((void*)&gcotan,"gcotan",1024);
  register_foreign_function((void*)&gcotanh,"gcotanh",1024);
  register_foreign_function((void*)&default0,"default0",1024);
  register_foreign_function((void*)&denominator,"denominator",1024);
  register_foreign_function((void*)&diffop0,"diffop0",1024);
  register_foreign_function((void*)&digits,"digits",1024);
  register_foreign_function((void*)&dilog,"dilog",1024);
  register_foreign_function((void*)&dirdiv,"dirdiv",1024);
  register_foreign_function((void*)&dirmul,"dirmul",1024);
  register_foreign_function((void*)&dirzetak,"dirzetak",1024);
  register_foreign_function((void*)&divisors0,"divisors0",1024);
  register_foreign_function((void*)&divisorslenstra,"divisorslenstra",1024);
  register_foreign_function((void*)&divrem,"divrem",1024);
  register_foreign_function((void*)&veceint1,"veceint1",1024);
  register_foreign_function((void*)&ellL1_bitprec,"ellL1_bitprec",1024);
  register_foreign_function((void*)&elladd,"elladd",1024);
  register_foreign_function((void*)&akell,"akell",1024);
  register_foreign_function((void*)&ellan,"ellan",1024);
  register_foreign_function((void*)&ellanalyticrank_bitprec,"ellanalyticrank_bitprec",1024);
  register_foreign_function((void*)&ellap,"ellap",1024);
  register_foreign_function((void*)&ellbsd,"ellbsd",1024);
  register_foreign_function((void*)&ellcard,"ellcard",1024);
  register_foreign_function((void*)&ellchangecurve,"ellchangecurve",1024);
  register_foreign_function((void*)&ellchangepoint,"ellchangepoint",1024);
  register_foreign_function((void*)&ellchangepointinv,"ellchangepointinv",1024);
  register_foreign_function((void*)&ellconvertname,"ellconvertname",1024);
  register_foreign_function((void*)&elldivpol,"elldivpol",1024);
  register_foreign_function((void*)&elleisnum,"elleisnum",1024);
  register_foreign_function((void*)&elleta,"elleta",1024);
  register_foreign_function((void*)&ellformaldifferential,"ellformaldifferential",1024);
  register_foreign_function((void*)&ellformalexp,"ellformalexp",1024);
  register_foreign_function((void*)&ellformallog,"ellformallog",1024);
  register_foreign_function((void*)&ellformalpoint,"ellformalpoint",1024);
  register_foreign_function((void*)&ellformalw,"ellformalw",1024);
  register_foreign_function((void*)&ellfromeqn,"ellfromeqn",1024);
  register_foreign_function((void*)&ellfromj,"ellfromj",1024);
  register_foreign_function((void*)&ellgenerators,"ellgenerators",1024);
  register_foreign_function((void*)&ellglobalred,"ellglobalred",1024);
  register_foreign_function((void*)&ellgroup0,"ellgroup0",1024);
  register_foreign_function((void*)&ellheegner,"ellheegner",1024);
  register_foreign_function((void*)&ellheight0,"ellheight0",1024);
  register_foreign_function((void*)&ellheightmatrix,"ellheightmatrix",1024);
  register_foreign_function((void*)&ellidentify,"ellidentify",1024);
  register_foreign_function((void*)&ellinit,"ellinit",1024);
  register_foreign_function((void*)&ellintegralmodel,"ellintegralmodel",1024);
  register_foreign_function((void*)&ellisdivisible,"ellisdivisible",1024);
  register_foreign_function((void*)&ellisogeny,"ellisogeny",1024);
  register_foreign_function((void*)&ellisogenyapply,"ellisogenyapply",1024);
  register_foreign_function((void*)&ellisomat,"ellisomat",1024);
  register_foreign_function((void*)&ellisoncurve,"ellisoncurve",1024);
  register_foreign_function((void*)&ellisotree,"ellisotree",1024);
  register_foreign_function((void*)&ellissupersingular,"ellissupersingular",1024);
  register_foreign_function((void*)&jell,"jell",1024);
  register_foreign_function((void*)&elllocalred,"elllocalred",1024);
  register_foreign_function((void*)&elllog,"elllog",1024);
  register_foreign_function((void*)&ellminimaldisc,"ellminimaldisc",1024);
  register_foreign_function((void*)&ellminimalmodel,"ellminimalmodel",1024);
  register_foreign_function((void*)&ellminimaltwist0,"ellminimaltwist0",1024);
  register_foreign_function((void*)&ellmoddegree,"ellmoddegree",1024);
  register_foreign_function((void*)&ellmodulareqn,"ellmodulareqn",1024);
  register_foreign_function((void*)&ellmul,"ellmul",1024);
  register_foreign_function((void*)&ellneg,"ellneg",1024);
  register_foreign_function((void*)&ellnonsingularmultiple,"ellnonsingularmultiple",1024);
  register_foreign_function((void*)&ellorder,"ellorder",1024);
  register_foreign_function((void*)&ellordinate,"ellordinate",1024);
  register_foreign_function((void*)&ellpadicL,"ellpadicL",1024);
  register_foreign_function((void*)&ellpadicbsd,"ellpadicbsd",1024);
  register_foreign_function((void*)&ellpadicfrobenius,"ellpadicfrobenius",1024);
  register_foreign_function((void*)&ellpadicheight0,"ellpadicheight0",1024);
  register_foreign_function((void*)&ellpadicheightmatrix,"ellpadicheightmatrix",1024);
  register_foreign_function((void*)&ellpadiclog,"ellpadiclog",1024);
  register_foreign_function((void*)&ellpadicregulator,"ellpadicregulator",1024);
  register_foreign_function((void*)&ellpadics2,"ellpadics2",1024);
  register_foreign_function((void*)&ellperiods,"ellperiods",1024);
  register_foreign_function((void*)&zell,"zell",1024);
  register_foreign_function((void*)&ellratpoints,"ellratpoints",1024);
  register_foreign_function((void*)&ellrootno,"ellrootno",1024);
  register_foreign_function((void*)&ellsea,"ellsea",1024);
  register_foreign_function((void*)&ellsearch,"ellsearch",1024);
  register_foreign_function((void*)&ellsigma,"ellsigma",1024);
  register_foreign_function((void*)&ellsub,"ellsub",1024);
  register_foreign_function((void*)&elltamagawa,"elltamagawa",1024);
  register_foreign_function((void*)&elltaniyama,"elltaniyama",1024);
  register_foreign_function((void*)&elltatepairing,"elltatepairing",1024);
  register_foreign_function((void*)&elltors,"elltors",1024);
  register_foreign_function((void*)&elltwist,"elltwist",1024);
  register_foreign_function((void*)&ellweilcurve,"ellweilcurve",1024);
  register_foreign_function((void*)&ellweilpairing,"ellweilpairing",1024);
  register_foreign_function((void*)&ellwp0,"ellwp0",1024);
  register_foreign_function((void*)&ellxn,"ellxn",1024);
  register_foreign_function((void*)&ellzeta,"ellzeta",1024);
  register_foreign_function((void*)&pointell,"pointell",1024);
  register_foreign_function((void*)&gerfc,"gerfc",1024);
  register_foreign_function((void*)&errname,"errname",1024);
  register_foreign_function((void*)&error0,"error0",1024);
  register_foreign_function((void*)&eta0,"eta0",1024);
  register_foreign_function((void*)&eulerphi,"eulerphi",1024);
  register_foreign_function((void*)&geval_gp,"geval_gp",1024);
  register_foreign_function((void*)&gexp,"gexp",1024);
  register_foreign_function((void*)&gexpm1,"gexpm1",1024);
  register_foreign_function((void*)&gpexponent,"gpexponent",1024);
  register_foreign_function((void*)&gpextern,"gpextern",1024);
  register_foreign_function((void*)&externstr,"externstr",1024);
  register_foreign_function((void*)&factor0,"factor0",1024);
  register_foreign_function((void*)&factorback2,"factorback2",1024);
  register_foreign_function((void*)&mpfactr,"mpfactr",1024);
  register_foreign_function((void*)&factorint,"factorint",1024);
  register_foreign_function((void*)&factormod0,"factormod0",1024);
  register_foreign_function((void*)&factormodDDF,"factormodDDF",1024);
  register_foreign_function((void*)&factormodSQF,"factormodSQF",1024);
  register_foreign_function((void*)&factorpadic,"factorpadic",1024);
  register_foreign_function((void*)&ffcompomap,"ffcompomap",1024);
  register_foreign_function((void*)&ffembed,"ffembed",1024);
  register_foreign_function((void*)&ffextend,"ffextend",1024);
  register_foreign_function((void*)&fffrobenius,"fffrobenius",1024);
  register_foreign_function((void*)&ffgen,"ffgen",1024);
  register_foreign_function((void*)&ffinit,"ffinit",1024);
  register_foreign_function((void*)&ffinvmap,"ffinvmap",1024);
  register_foreign_function((void*)&fflog,"fflog",1024);
  register_foreign_function((void*)&ffmap,"ffmap",1024);
  register_foreign_function((void*)&ffnbirred0,"ffnbirred0",1024);
  register_foreign_function((void*)&fforder,"fforder",1024);
  register_foreign_function((void*)&ffprimroot,"ffprimroot",1024);
  register_foreign_function((void*)&fibo,"fibo",1024);
  register_foreign_function((void*)&gp_fileclose,"gp_fileclose",1024);
  register_foreign_function((void*)&gp_fileextern,"gp_fileextern",1024);
  register_foreign_function((void*)&gp_fileflush0,"gp_fileflush0",1024);
  register_foreign_function((void*)&gp_fileopen,"gp_fileopen",1024);
  register_foreign_function((void*)&gp_fileread,"gp_fileread",1024);
  register_foreign_function((void*)&gp_filereadstr,"gp_filereadstr",1024);
  register_foreign_function((void*)&gp_filewrite,"gp_filewrite",1024);
  register_foreign_function((void*)&gp_filewrite1,"gp_filewrite1",1024);
  register_foreign_function((void*)&gfloor,"gfloor",1024);
  register_foreign_function((void*)&forqfvec0,"forqfvec0",1024);
  register_foreign_function((void*)&gfrac,"gfrac",1024);
  register_foreign_function((void*)&fromdigits,"fromdigits",1024);
  register_foreign_function((void*)&galoischardet,"galoischardet",1024);
  register_foreign_function((void*)&galoischarpoly,"galoischarpoly",1024);
  register_foreign_function((void*)&galoischartable,"galoischartable",1024);
  register_foreign_function((void*)&galoisconjclasses,"galoisconjclasses",1024);
  register_foreign_function((void*)&galoisexport,"galoisexport",1024);
  register_foreign_function((void*)&galoisfixedfield,"galoisfixedfield",1024);
  register_foreign_function((void*)&galoisgetgroup,"galoisgetgroup",1024);
  register_foreign_function((void*)&galoisgetname,"galoisgetname",1024);
  register_foreign_function((void*)&galoisgetpol,"galoisgetpol",1024);
  register_foreign_function((void*)&galoisidentify,"galoisidentify",1024);
  register_foreign_function((void*)&galoisinit,"galoisinit",1024);
  register_foreign_function((void*)&galoisisabelian,"galoisisabelian",1024);
  register_foreign_function((void*)&galoisisnormal,"galoisisnormal",1024);
  register_foreign_function((void*)&galoispermtopol,"galoispermtopol",1024);
  register_foreign_function((void*)&galoissubcyclo,"galoissubcyclo",1024);
  register_foreign_function((void*)&galoissubfields,"galoissubfields",1024);
  register_foreign_function((void*)&galoissubgroups,"galoissubgroups",1024);
  register_foreign_function((void*)&ggamma,"ggamma",1024);
  register_foreign_function((void*)&ggammah,"ggammah",1024);
  register_foreign_function((void*)&gammamellininv,"gammamellininv",1024);
  register_foreign_function((void*)&gammamellininvasymp,"gammamellininvasymp",1024);
  register_foreign_function((void*)&gammamellininvinit,"gammamellininvinit",1024);
  register_foreign_function((void*)&ggcd0,"ggcd0",1024);
  register_foreign_function((void*)&gcdext0,"gcdext0",1024);
  register_foreign_function((void*)&genus2red,"genus2red",1024);
  register_foreign_function((void*)&getabstime,"getabstime",1024);
  register_foreign_function((void*)&getcache,"getcache",1024);
  register_foreign_function((void*)&gp_getenv,"gp_getenv",1024);
  register_foreign_function((void*)&getheap,"getheap",1024);
  register_foreign_function((void*)&getrand,"getrand",1024);
  register_foreign_function((void*)&getstack,"getstack",1024);
  register_foreign_function((void*)&gettime,"gettime",1024);
  register_foreign_function((void*)&getwalltime,"getwalltime",1024);
  register_foreign_function((void*)&hammingweight,"hammingweight",1024);
  register_foreign_function((void*)&hilbert,"hilbert",1024);
  register_foreign_function((void*)&hyperellcharpoly,"hyperellcharpoly",1024);
  register_foreign_function((void*)&hyperellpadicfrobenius,"hyperellpadicfrobenius",1024);
  register_foreign_function((void*)&hyperellratpoints,"hyperellratpoints",1024);
  register_foreign_function((void*)&hyperu,"hyperu",1024);
  register_foreign_function((void*)&idealadd,"idealadd",1024);
  register_foreign_function((void*)&idealaddtoone0,"idealaddtoone0",1024);
  register_foreign_function((void*)&idealappr0,"idealappr0",1024);
  register_foreign_function((void*)&idealchinese,"idealchinese",1024);
  register_foreign_function((void*)&idealcoprime,"idealcoprime",1024);
  register_foreign_function((void*)&idealdiv0,"idealdiv0",1024);
  register_foreign_function((void*)&gpidealfactor,"gpidealfactor",1024);
  register_foreign_function((void*)&idealfactorback,"idealfactorback",1024);
  register_foreign_function((void*)&idealfrobenius,"idealfrobenius",1024);
  register_foreign_function((void*)&idealhnf0,"idealhnf0",1024);
  register_foreign_function((void*)&idealintersect,"idealintersect",1024);
  register_foreign_function((void*)&idealinv,"idealinv",1024);
  register_foreign_function((void*)&idealispower,"idealispower",1024);
  register_foreign_function((void*)&ideallist0,"ideallist0",1024);
  register_foreign_function((void*)&ideallistarch,"ideallistarch",1024);
  register_foreign_function((void*)&ideallog,"ideallog",1024);
  register_foreign_function((void*)&idealmin,"idealmin",1024);
  register_foreign_function((void*)&idealmul0,"idealmul0",1024);
  register_foreign_function((void*)&idealnorm,"idealnorm",1024);
  register_foreign_function((void*)&idealnumden,"idealnumden",1024);
  register_foreign_function((void*)&idealpow0,"idealpow0",1024);
  register_foreign_function((void*)&idealprimedec_limit_f,"idealprimedec_limit_f",1024);
  register_foreign_function((void*)&idealprincipalunits,"idealprincipalunits",1024);
  register_foreign_function((void*)&idealramgroups,"idealramgroups",1024);
  register_foreign_function((void*)&idealred0,"idealred0",1024);
  register_foreign_function((void*)&idealredmodpower,"idealredmodpower",1024);
  register_foreign_function((void*)&idealstar0,"idealstar0",1024);
  register_foreign_function((void*)&idealtwoelt0,"idealtwoelt0",1024);
  register_foreign_function((void*)&gpidealval,"gpidealval",1024);
  register_foreign_function((void*)&gimag,"gimag",1024);
  register_foreign_function((void*)&incgam0,"incgam0",1024);
  register_foreign_function((void*)&incgamc,"incgamc",1024);
  register_foreign_function((void*)&gp_input,"gp_input",1024);
  register_foreign_function((void*)&gpinstall,"gpinstall",1024);
  register_foreign_function((void*)&integ,"integ",1024);
  register_foreign_function((void*)&isfundamental,"isfundamental",1024);
  register_foreign_function((void*)&ispolygonal,"ispolygonal",1024);
  register_foreign_function((void*)&ispower,"ispower",1024);
  register_foreign_function((void*)&ispowerful,"ispowerful",1024);
  register_foreign_function((void*)&gisprime,"gisprime",1024);
  register_foreign_function((void*)&isprimepower,"isprimepower",1024);
  register_foreign_function((void*)&gispseudoprime,"gispseudoprime",1024);
  register_foreign_function((void*)&ispseudoprimepower,"ispseudoprimepower",1024);
  register_foreign_function((void*)&issquareall,"issquareall",1024);
  register_foreign_function((void*)&issquarefree,"issquarefree",1024);
  register_foreign_function((void*)&istotient,"istotient",1024);
  register_foreign_function((void*)&kill0,"kill0",1024);
  register_foreign_function((void*)&kronecker,"kronecker",1024);
  register_foreign_function((void*)&glambertW,"glambertW",1024);
  register_foreign_function((void*)&glcm0,"glcm0",1024);
  register_foreign_function((void*)&lexcmp,"lexcmp",1024);
  register_foreign_function((void*)&lfun0,"lfun0",1024);
  register_foreign_function((void*)&lfunabelianrelinit,"lfunabelianrelinit",1024);
  register_foreign_function((void*)&lfunan,"lfunan",1024);
  register_foreign_function((void*)&lfunartin,"lfunartin",1024);
  register_foreign_function((void*)&lfuncheckfeq,"lfuncheckfeq",1024);
  register_foreign_function((void*)&lfunconductor,"lfunconductor",1024);
  register_foreign_function((void*)&lfuncost0,"lfuncost0",1024);
  register_foreign_function((void*)&lfuncreate,"lfuncreate",1024);
  register_foreign_function((void*)&lfundiv,"lfundiv",1024);
  register_foreign_function((void*)&lfunetaquo,"lfunetaquo",1024);
  register_foreign_function((void*)&lfungenus2,"lfungenus2",1024);
  register_foreign_function((void*)&lfunhardy,"lfunhardy",1024);
  register_foreign_function((void*)&lfuninit0,"lfuninit0",1024);
  register_foreign_function((void*)&lfunlambda0,"lfunlambda0",1024);
  register_foreign_function((void*)&lfunmf,"lfunmf",1024);
  register_foreign_function((void*)&lfunmfspec,"lfunmfspec",1024);
  register_foreign_function((void*)&lfunmul,"lfunmul",1024);
  register_foreign_function((void*)&lfunorderzero,"lfunorderzero",1024);
  register_foreign_function((void*)&lfunqf,"lfunqf",1024);
  register_foreign_function((void*)&lfunrootres,"lfunrootres",1024);
  register_foreign_function((void*)&lfunsympow,"lfunsympow",1024);
  register_foreign_function((void*)&lfuntheta,"lfuntheta",1024);
  register_foreign_function((void*)&lfunthetacost0,"lfunthetacost0",1024);
  register_foreign_function((void*)&lfunthetainit,"lfunthetainit",1024);
  register_foreign_function((void*)&lfuntwist,"lfuntwist",1024);
  register_foreign_function((void*)&lfunzeros,"lfunzeros",1024);
  register_foreign_function((void*)&lift0,"lift0",1024);
  register_foreign_function((void*)&liftall,"liftall",1024);
  register_foreign_function((void*)&liftint,"liftint",1024);
  register_foreign_function((void*)&liftpol,"liftpol",1024);
  register_foreign_function((void*)&lindep0,"lindep0",1024);
  register_foreign_function((void*)&listinsert,"listinsert",1024);
  register_foreign_function((void*)&listpop0,"listpop0",1024);
  register_foreign_function((void*)&listput0,"listput0",1024);
  register_foreign_function((void*)&listsort,"listsort",1024);
  register_foreign_function((void*)&glngamma,"glngamma",1024);
  register_foreign_function((void*)&localbitprec,"localbitprec",1024);
  register_foreign_function((void*)&localprec,"localprec",1024);
  register_foreign_function((void*)&glog,"glog",1024);
  register_foreign_function((void*)&glog1p,"glog1p",1024);
  register_foreign_function((void*)&logint0,"logint0",1024);
  register_foreign_function((void*)&mapdelete,"mapdelete",1024);
  register_foreign_function((void*)&mapget,"mapget",1024);
  register_foreign_function((void*)&mapisdefined,"mapisdefined",1024);
  register_foreign_function((void*)&mapput,"mapput",1024);
  register_foreign_function((void*)&matadjoint0,"matadjoint0",1024);
  register_foreign_function((void*)&matcompanion,"matcompanion",1024);
  register_foreign_function((void*)&matconcat,"matconcat",1024);
  register_foreign_function((void*)&det0,"det0",1024);
  register_foreign_function((void*)&detint,"detint",1024);
  register_foreign_function((void*)&matdetmod,"matdetmod",1024);
  register_foreign_function((void*)&diagonal,"diagonal",1024);
  register_foreign_function((void*)&mateigen,"mateigen",1024);
  register_foreign_function((void*)&matfrobenius,"matfrobenius",1024);
  register_foreign_function((void*)&hess,"hess",1024);
  register_foreign_function((void*)&mathilbert,"mathilbert",1024);
  register_foreign_function((void*)&mathnf0,"mathnf0",1024);
  register_foreign_function((void*)&hnfmod,"hnfmod",1024);
  register_foreign_function((void*)&hnfmodid,"hnfmodid",1024);
  register_foreign_function((void*)&mathouseholder,"mathouseholder",1024);
  register_foreign_function((void*)&matid,"matid",1024);
  register_foreign_function((void*)&matimage0,"matimage0",1024);
  register_foreign_function((void*)&imagecompl,"imagecompl",1024);
  register_foreign_function((void*)&matimagemod,"matimagemod",1024);
  register_foreign_function((void*)&indexrank,"indexrank",1024);
  register_foreign_function((void*)&intersect,"intersect",1024);
  register_foreign_function((void*)&inverseimage,"inverseimage",1024);
  register_foreign_function((void*)&matinvmod,"matinvmod",1024);
  register_foreign_function((void*)&isdiagonal,"isdiagonal",1024);
  register_foreign_function((void*)&matker0,"matker0",1024);
  register_foreign_function((void*)&matkerint0,"matkerint0",1024);
  register_foreign_function((void*)&matkermod,"matkermod",1024);
  register_foreign_function((void*)&matmuldiagonal,"matmuldiagonal",1024);
  register_foreign_function((void*)&matmultodiagonal,"matmultodiagonal",1024);
  register_foreign_function((void*)&matqpascal,"matqpascal",1024);
  register_foreign_function((void*)&matpermanent,"matpermanent",1024);
  register_foreign_function((void*)&matqr,"matqr",1024);
  register_foreign_function((void*)&rank,"rank",1024);
  register_foreign_function((void*)&matrice,"matrice",1024);
  register_foreign_function((void*)&matrixqz0,"matrixqz0",1024);
  register_foreign_function((void*)&matsize,"matsize",1024);
  register_foreign_function((void*)&matsnf0,"matsnf0",1024);
  register_foreign_function((void*)&gauss,"gauss",1024);
  register_foreign_function((void*)&matsolvemod,"matsolvemod",1024);
  register_foreign_function((void*)&suppl,"suppl",1024);
  register_foreign_function((void*)&gmax,"gmax",1024);
  register_foreign_function((void*)&mfDelta,"mfDelta",1024);
  register_foreign_function((void*)&mfEH,"mfEH",1024);
  register_foreign_function((void*)&mfEk,"mfEk",1024);
  register_foreign_function((void*)&mfTheta,"mfTheta",1024);
  register_foreign_function((void*)&mfatkin,"mfatkin",1024);
  register_foreign_function((void*)&mfatkineigenvalues,"mfatkineigenvalues",1024);
  register_foreign_function((void*)&mfatkininit,"mfatkininit",1024);
  register_foreign_function((void*)&mfbasis,"mfbasis",1024);
  register_foreign_function((void*)&mfbd,"mfbd",1024);
  register_foreign_function((void*)&mfbracket,"mfbracket",1024);
  register_foreign_function((void*)&mfcoef,"mfcoef",1024);
  register_foreign_function((void*)&mfcoefs,"mfcoefs",1024);
  register_foreign_function((void*)&mfconductor,"mfconductor",1024);
  register_foreign_function((void*)&mfcosets,"mfcosets",1024);
  register_foreign_function((void*)&mfcuspisregular,"mfcuspisregular",1024);
  register_foreign_function((void*)&mfcusps,"mfcusps",1024);
  register_foreign_function((void*)&mfcuspval,"mfcuspval",1024);
  register_foreign_function((void*)&mfcuspwidth,"mfcuspwidth",1024);
  register_foreign_function((void*)&mfderiv,"mfderiv",1024);
  register_foreign_function((void*)&mfderivE2,"mfderivE2",1024);
  register_foreign_function((void*)&mfdescribe,"mfdescribe",1024);
  register_foreign_function((void*)&mfdim,"mfdim",1024);
  register_foreign_function((void*)&mfdiv,"mfdiv",1024);
  register_foreign_function((void*)&mfeigenbasis,"mfeigenbasis",1024);
  register_foreign_function((void*)&mfeigensearch,"mfeigensearch",1024);
  register_foreign_function((void*)&mfeisenstein,"mfeisenstein",1024);
  register_foreign_function((void*)&mfembed0,"mfembed0",1024);
  register_foreign_function((void*)&mfeval,"mfeval",1024);
  register_foreign_function((void*)&mffields,"mffields",1024);
  register_foreign_function((void*)&mffromell,"mffromell",1024);
  register_foreign_function((void*)&mffrometaquo,"mffrometaquo",1024);
  register_foreign_function((void*)&mffromlfun,"mffromlfun",1024);
  register_foreign_function((void*)&mffromqf,"mffromqf",1024);
  register_foreign_function((void*)&mfgaloistype,"mfgaloistype",1024);
  register_foreign_function((void*)&mfhecke,"mfhecke",1024);
  register_foreign_function((void*)&mfheckemat,"mfheckemat",1024);
  register_foreign_function((void*)&mfinit,"mfinit",1024);
  register_foreign_function((void*)&mfisCM,"mfisCM",1024);
  register_foreign_function((void*)&mfisequal,"mfisequal",1024);
  register_foreign_function((void*)&mfkohnenbasis,"mfkohnenbasis",1024);
  register_foreign_function((void*)&mfkohnenbijection,"mfkohnenbijection",1024);
  register_foreign_function((void*)&mfkohneneigenbasis,"mfkohneneigenbasis",1024);
  register_foreign_function((void*)&mflinear,"mflinear",1024);
  register_foreign_function((void*)&mfmanin,"mfmanin",1024);
  register_foreign_function((void*)&mfmul,"mfmul",1024);
  register_foreign_function((void*)&mfnumcusps,"mfnumcusps",1024);
  register_foreign_function((void*)&mfparams,"mfparams",1024);
  register_foreign_function((void*)&mfperiodpol,"mfperiodpol",1024);
  register_foreign_function((void*)&mfperiodpolbasis,"mfperiodpolbasis",1024);
  register_foreign_function((void*)&mfpetersson,"mfpetersson",1024);
  register_foreign_function((void*)&mfpow,"mfpow",1024);
  register_foreign_function((void*)&mfsearch,"mfsearch",1024);
  register_foreign_function((void*)&mfshift,"mfshift",1024);
  register_foreign_function((void*)&mfshimura,"mfshimura",1024);
  register_foreign_function((void*)&mfslashexpansion,"mfslashexpansion",1024);
  register_foreign_function((void*)&mfspace,"mfspace",1024);
  register_foreign_function((void*)&mfsplit,"mfsplit",1024);
  register_foreign_function((void*)&mfsturm,"mfsturm",1024);
  register_foreign_function((void*)&mfsymbol,"mfsymbol",1024);
  register_foreign_function((void*)&mfsymboleval,"mfsymboleval",1024);
  register_foreign_function((void*)&mftaylor,"mftaylor",1024);
  register_foreign_function((void*)&mftobasis,"mftobasis",1024);
  register_foreign_function((void*)&mftocoset,"mftocoset",1024);
  register_foreign_function((void*)&mftonew,"mftonew",1024);
  register_foreign_function((void*)&mftraceform,"mftraceform",1024);
  register_foreign_function((void*)&mftwist,"mftwist",1024);
  register_foreign_function((void*)&gmin,"gmin",1024);
  register_foreign_function((void*)&minpoly,"minpoly",1024);
  register_foreign_function((void*)&modreverse,"modreverse",1024);
  register_foreign_function((void*)&moebius,"moebius",1024);
  register_foreign_function((void*)&msatkinlehner,"msatkinlehner",1024);
  register_foreign_function((void*)&mscuspidal,"mscuspidal",1024);
  register_foreign_function((void*)&msdim,"msdim",1024);
  register_foreign_function((void*)&mseisenstein,"mseisenstein",1024);
  register_foreign_function((void*)&mseval,"mseval",1024);
  register_foreign_function((void*)&msfromcusp,"msfromcusp",1024);
  register_foreign_function((void*)&msfromell,"msfromell",1024);
  register_foreign_function((void*)&msfromhecke,"msfromhecke",1024);
  register_foreign_function((void*)&msgetlevel,"msgetlevel",1024);
  register_foreign_function((void*)&msgetsign,"msgetsign",1024);
  register_foreign_function((void*)&msgetweight,"msgetweight",1024);
  register_foreign_function((void*)&mshecke,"mshecke",1024);
  register_foreign_function((void*)&msinit,"msinit",1024);
  register_foreign_function((void*)&msissymbol,"msissymbol",1024);
  register_foreign_function((void*)&mslattice,"mslattice",1024);
  register_foreign_function((void*)&msnew,"msnew",1024);
  register_foreign_function((void*)&msomseval,"msomseval",1024);
  register_foreign_function((void*)&mspadicL,"mspadicL",1024);
  register_foreign_function((void*)&mspadicinit,"mspadicinit",1024);
  register_foreign_function((void*)&mspadicmoments,"mspadicmoments",1024);
  register_foreign_function((void*)&mspadicseries,"mspadicseries",1024);
  register_foreign_function((void*)&mspathgens,"mspathgens",1024);
  register_foreign_function((void*)&mspathlog,"mspathlog",1024);
  register_foreign_function((void*)&mspetersson,"mspetersson",1024);
  register_foreign_function((void*)&mspolygon,"mspolygon",1024);
  register_foreign_function((void*)&msqexpansion,"msqexpansion",1024);
  register_foreign_function((void*)&mssplit,"mssplit",1024);
  register_foreign_function((void*)&msstar,"msstar",1024);
  register_foreign_function((void*)&mstooms,"mstooms",1024);
  register_foreign_function((void*)&newtonpoly,"newtonpoly",1024);
  register_foreign_function((void*)&nextprime,"nextprime",1024);
  register_foreign_function((void*)&algtobasis,"algtobasis",1024);
  register_foreign_function((void*)&nfbasis_gp,"nfbasis_gp",1024);
  register_foreign_function((void*)&basistoalg,"basistoalg",1024);
  register_foreign_function((void*)&nfcertify,"nfcertify",1024);
  register_foreign_function((void*)&nfcompositum,"nfcompositum",1024);
  register_foreign_function((void*)&nfdetint,"nfdetint",1024);
  register_foreign_function((void*)&nfdisc,"nfdisc",1024);
  register_foreign_function((void*)&nfadd,"nfadd",1024);
  register_foreign_function((void*)&nfdiv,"nfdiv",1024);
  register_foreign_function((void*)&nfdiveuc,"nfdiveuc",1024);
  register_foreign_function((void*)&nfdivrem,"nfdivrem",1024);
  register_foreign_function((void*)&nfeltembed,"nfeltembed",1024);
  register_foreign_function((void*)&nfmod,"nfmod",1024);
  register_foreign_function((void*)&nfmul,"nfmul",1024);
  register_foreign_function((void*)&nfnorm,"nfnorm",1024);
  register_foreign_function((void*)&nfpow,"nfpow",1024);
  register_foreign_function((void*)&nfreduce,"nfreduce",1024);
  register_foreign_function((void*)&nfeltsign,"nfeltsign",1024);
  register_foreign_function((void*)&nftrace,"nftrace",1024);
  register_foreign_function((void*)&gpnfvalrem,"gpnfvalrem",1024);
  register_foreign_function((void*)&nffactor,"nffactor",1024);
  register_foreign_function((void*)&nffactorback,"nffactorback",1024);
  register_foreign_function((void*)&galoisapply,"galoisapply",1024);
  register_foreign_function((void*)&galoisconj0,"galoisconj0",1024);
  register_foreign_function((void*)&nfgrunwaldwang,"nfgrunwaldwang",1024);
  register_foreign_function((void*)&nfhilbert0,"nfhilbert0",1024);
  register_foreign_function((void*)&nfhnf0,"nfhnf0",1024);
  register_foreign_function((void*)&nfhnfmod,"nfhnfmod",1024);
  register_foreign_function((void*)&nfinit0,"nfinit0",1024);
  register_foreign_function((void*)&isideal,"isideal",1024);
  register_foreign_function((void*)&nfisincl,"nfisincl",1024);
  register_foreign_function((void*)&nfisisom,"nfisisom",1024);
  register_foreign_function((void*)&nfislocalpower,"nfislocalpower",1024);
  register_foreign_function((void*)&nfmodpr,"nfmodpr",1024);
  register_foreign_function((void*)&nfmodprinit,"nfmodprinit",1024);
  register_foreign_function((void*)&nfmodprlift,"nfmodprlift",1024);
  register_foreign_function((void*)&nfnewprec,"nfnewprec",1024);
  register_foreign_function((void*)&nfpolsturm,"nfpolsturm",1024);
  register_foreign_function((void*)&nfroots,"nfroots",1024);
  register_foreign_function((void*)&rootsof1,"rootsof1",1024);
  register_foreign_function((void*)&nfsnf0,"nfsnf0",1024);
  register_foreign_function((void*)&nfsplitting,"nfsplitting",1024);
  register_foreign_function((void*)&nfsubfields,"nfsubfields",1024);
  register_foreign_function((void*)&gnorm,"gnorm",1024);
  register_foreign_function((void*)&gnorml2,"gnorml2",1024);
  register_foreign_function((void*)&gnormlp,"gnormlp",1024);
  register_foreign_function((void*)&numbpart,"numbpart",1024);
  register_foreign_function((void*)&numdiv,"numdiv",1024);
  register_foreign_function((void*)&numerator,"numerator",1024);
  register_foreign_function((void*)&numtoperm,"numtoperm",1024);
  register_foreign_function((void*)&omega,"omega",1024);
  register_foreign_function((void*)&padicappr,"padicappr",1024);
  register_foreign_function((void*)&padicfields0,"padicfields0",1024);
  register_foreign_function((void*)&gppadicprec,"gppadicprec",1024);
  register_foreign_function((void*)&partitions,"partitions",1024);
  register_foreign_function((void*)&permorder,"permorder",1024);
  register_foreign_function((void*)&permsign,"permsign",1024);
  register_foreign_function((void*)&permtonum,"permtonum",1024);
  register_foreign_function((void*)&polchebyshev_eval,"polchebyshev_eval",1024);
  register_foreign_function((void*)&polclass,"polclass",1024);
  register_foreign_function((void*)&polcoef,"polcoef",1024);
  register_foreign_function((void*)&polcompositum0,"polcompositum0",1024);
  register_foreign_function((void*)&polcyclo_eval,"polcyclo_eval",1024);
  register_foreign_function((void*)&polcyclofactors,"polcyclofactors",1024);
  register_foreign_function((void*)&gppoldegree,"gppoldegree",1024);
  register_foreign_function((void*)&poldisc0,"poldisc0",1024);
  register_foreign_function((void*)&poldiscfactors,"poldiscfactors",1024);
  register_foreign_function((void*)&reduceddiscsmith,"reduceddiscsmith",1024);
  register_foreign_function((void*)&polgalois,"polgalois",1024);
  register_foreign_function((void*)&polgraeffe,"polgraeffe",1024);
  register_foreign_function((void*)&polhensellift,"polhensellift",1024);
  register_foreign_function((void*)&polhermite_eval,"polhermite_eval",1024);
  register_foreign_function((void*)&polint,"polint",1024);
  register_foreign_function((void*)&poliscyclo,"poliscyclo",1024);
  register_foreign_function((void*)&poliscycloprod,"poliscycloprod",1024);
  register_foreign_function((void*)&isirreducible,"isirreducible",1024);
  register_foreign_function((void*)&pollead,"pollead",1024);
  register_foreign_function((void*)&pollegendre_eval,"pollegendre_eval",1024);
  register_foreign_function((void*)&polmodular,"polmodular",1024);
  register_foreign_function((void*)&polrecip,"polrecip",1024);
  register_foreign_function((void*)&polredabs0,"polredabs0",1024);
  register_foreign_function((void*)&polredbest,"polredbest",1024);
  register_foreign_function((void*)&polresultant0,"polresultant0",1024);
  register_foreign_function((void*)&polresultantext0,"polresultantext0",1024);
  register_foreign_function((void*)&roots,"roots",1024);
  register_foreign_function((void*)&polrootsbound,"polrootsbound",1024);
  register_foreign_function((void*)&polrootsmod,"polrootsmod",1024);
  register_foreign_function((void*)&rootpadic,"rootpadic",1024);
  register_foreign_function((void*)&realroots,"realroots",1024);
  register_foreign_function((void*)&sturmpart,"sturmpart",1024);
  register_foreign_function((void*)&polsubcyclo,"polsubcyclo",1024);
  register_foreign_function((void*)&sylvestermatrix,"sylvestermatrix",1024);
  register_foreign_function((void*)&polsym,"polsym",1024);
  register_foreign_function((void*)&tschirnhaus,"tschirnhaus",1024);
  register_foreign_function((void*)&polylog0,"polylog0",1024);
  register_foreign_function((void*)&polzag,"polzag",1024);
  register_foreign_function((void*)&gpowers0,"gpowers0",1024);
  register_foreign_function((void*)&precision0,"precision0",1024);
  register_foreign_function((void*)&precprime,"precprime",1024);
  register_foreign_function((void*)&prime,"prime",1024);
  register_foreign_function((void*)&primecert,"primecert",1024);
  register_foreign_function((void*)&primecertexport,"primecertexport",1024);
  register_foreign_function((void*)&primecertisvalid,"primecertisvalid",1024);
  register_foreign_function((void*)&primepi,"primepi",1024);
  register_foreign_function((void*)&primes0,"primes0",1024);
  register_foreign_function((void*)&print,"print",1024);
  register_foreign_function((void*)&print1,"print1",1024);
  register_foreign_function((void*)&printf0,"printf0",1024);
  register_foreign_function((void*)&printp,"printp",1024);
  register_foreign_function((void*)&printsep,"printsep",1024);
  register_foreign_function((void*)&printsep1,"printsep1",1024);
  register_foreign_function((void*)&printtex,"printtex",1024);
  register_foreign_function((void*)&gpsi,"gpsi",1024);
  register_foreign_function((void*)&qfauto0,"qfauto0",1024);
  register_foreign_function((void*)&qfautoexport,"qfautoexport",1024);
  register_foreign_function((void*)&qfbclassno0,"qfbclassno0",1024);
  register_foreign_function((void*)&qfbcompraw,"qfbcompraw",1024);
  register_foreign_function((void*)&hclassno,"hclassno",1024);
  register_foreign_function((void*)&nucomp,"nucomp",1024);
  register_foreign_function((void*)&nupow,"nupow",1024);
  register_foreign_function((void*)&qfbpowraw,"qfbpowraw",1024);
  register_foreign_function((void*)&primeform,"primeform",1024);
  register_foreign_function((void*)&qfbred0,"qfbred0",1024);
  register_foreign_function((void*)&qfbredsl2,"qfbredsl2",1024);
  register_foreign_function((void*)&qfbsolve,"qfbsolve",1024);
  register_foreign_function((void*)&qfeval0,"qfeval0",1024);
  register_foreign_function((void*)&qfgaussred,"qfgaussred",1024);
  register_foreign_function((void*)&qfisom0,"qfisom0",1024);
  register_foreign_function((void*)&qfisominit0,"qfisominit0",1024);
  register_foreign_function((void*)&jacobi,"jacobi",1024);
  register_foreign_function((void*)&qflll0,"qflll0",1024);
  register_foreign_function((void*)&qflllgram0,"qflllgram0",1024);
  register_foreign_function((void*)&qfminim0,"qfminim0",1024);
  register_foreign_function((void*)&qforbits,"qforbits",1024);
  register_foreign_function((void*)&qfparam,"qfparam",1024);
  register_foreign_function((void*)&perf,"perf",1024);
  register_foreign_function((void*)&qfrep0,"qfrep0",1024);
  register_foreign_function((void*)&qfsign,"qfsign",1024);
  register_foreign_function((void*)&qfsolve,"qfsolve",1024);
  register_foreign_function((void*)&quadclassunit0,"quadclassunit0",1024);
  register_foreign_function((void*)&quaddisc,"quaddisc",1024);
  register_foreign_function((void*)&quadgen0,"quadgen0",1024);
  register_foreign_function((void*)&quadhilbert,"quadhilbert",1024);
  register_foreign_function((void*)&quadpoly0,"quadpoly0",1024);
  register_foreign_function((void*)&quadray,"quadray",1024);
  register_foreign_function((void*)&quadregulator,"quadregulator",1024);
  register_foreign_function((void*)&quadunit0,"quadunit0",1024);
  register_foreign_function((void*)&ramanujantau,"ramanujantau",1024);
  register_foreign_function((void*)&genrand,"genrand",1024);
  register_foreign_function((void*)&randomprime,"randomprime",1024);
  register_foreign_function((void*)&gp_read_file,"gp_read_file",1024);
  register_foreign_function((void*)&readstr,"readstr",1024);
  register_foreign_function((void*)&gp_readvec_file,"gp_readvec_file",1024);
  register_foreign_function((void*)&greal,"greal",1024);
  register_foreign_function((void*)&removeprimes,"removeprimes",1024);
  register_foreign_function((void*)&rnfalgtobasis,"rnfalgtobasis",1024);
  register_foreign_function((void*)&rnfbasis,"rnfbasis",1024);
  register_foreign_function((void*)&rnfbasistoalg,"rnfbasistoalg",1024);
  register_foreign_function((void*)&rnfcharpoly,"rnfcharpoly",1024);
  register_foreign_function((void*)&rnfconductor,"rnfconductor",1024);
  register_foreign_function((void*)&rnfdedekind,"rnfdedekind",1024);
  register_foreign_function((void*)&rnfdet,"rnfdet",1024);
  register_foreign_function((void*)&rnfdiscf,"rnfdiscf",1024);
  register_foreign_function((void*)&rnfeltabstorel,"rnfeltabstorel",1024);
  register_foreign_function((void*)&rnfeltdown0,"rnfeltdown0",1024);
  register_foreign_function((void*)&rnfeltnorm,"rnfeltnorm",1024);
  register_foreign_function((void*)&rnfeltreltoabs,"rnfeltreltoabs",1024);
  register_foreign_function((void*)&rnfelttrace,"rnfelttrace",1024);
  register_foreign_function((void*)&rnfeltup0,"rnfeltup0",1024);
  register_foreign_function((void*)&rnfequation0,"rnfequation0",1024);
  register_foreign_function((void*)&rnfhnfbasis,"rnfhnfbasis",1024);
  register_foreign_function((void*)&rnfidealabstorel,"rnfidealabstorel",1024);
  register_foreign_function((void*)&rnfidealdown,"rnfidealdown",1024);
  register_foreign_function((void*)&rnfidealfactor,"rnfidealfactor",1024);
  register_foreign_function((void*)&rnfidealhnf,"rnfidealhnf",1024);
  register_foreign_function((void*)&rnfidealmul,"rnfidealmul",1024);
  register_foreign_function((void*)&rnfidealnormabs,"rnfidealnormabs",1024);
  register_foreign_function((void*)&rnfidealnormrel,"rnfidealnormrel",1024);
  register_foreign_function((void*)&rnfidealprimedec,"rnfidealprimedec",1024);
  register_foreign_function((void*)&rnfidealreltoabs0,"rnfidealreltoabs0",1024);
  register_foreign_function((void*)&rnfidealtwoelement,"rnfidealtwoelement",1024);
  register_foreign_function((void*)&rnfidealup0,"rnfidealup0",1024);
  register_foreign_function((void*)&rnfinit0,"rnfinit0",1024);
  register_foreign_function((void*)&rnfisabelian,"rnfisabelian",1024);
  register_foreign_function((void*)&rnfisfree,"rnfisfree",1024);
  register_foreign_function((void*)&rnfislocalcyclo,"rnfislocalcyclo",1024);
  register_foreign_function((void*)&rnfisnorm,"rnfisnorm",1024);
  register_foreign_function((void*)&rnfisnorminit,"rnfisnorminit",1024);
  register_foreign_function((void*)&rnfkummer,"rnfkummer",1024);
  register_foreign_function((void*)&rnflllgram,"rnflllgram",1024);
  register_foreign_function((void*)&rnfnormgroup,"rnfnormgroup",1024);
  register_foreign_function((void*)&rnfpolredabs,"rnfpolredabs",1024);
  register_foreign_function((void*)&rnfpolredbest,"rnfpolredbest",1024);
  register_foreign_function((void*)&rnfpseudobasis,"rnfpseudobasis",1024);
  register_foreign_function((void*)&rnfsteinitz,"rnfsteinitz",1024);
  register_foreign_function((void*)&round0,"round0",1024);
  register_foreign_function((void*)&pari_self,"pari_self",1024);
  register_foreign_function((void*)&seralgdep,"seralgdep",1024);
  register_foreign_function((void*)&serchop,"serchop",1024);
  register_foreign_function((void*)&convol,"convol",1024);
  register_foreign_function((void*)&laplace,"laplace",1024);
  register_foreign_function((void*)&gpserprec,"gpserprec",1024);
  register_foreign_function((void*)&serreverse,"serreverse",1024);
  register_foreign_function((void*)&setbinop,"setbinop",1024);
  register_foreign_function((void*)&setintersect,"setintersect",1024);
  register_foreign_function((void*)&setisset,"setisset",1024);
  register_foreign_function((void*)&setminus,"setminus",1024);
  register_foreign_function((void*)&setrand,"setrand",1024);
  register_foreign_function((void*)&setsearch,"setsearch",1024);
  register_foreign_function((void*)&setunion,"setunion",1024);
  register_foreign_function((void*)&gmul2n,"gmul2n",1024);
  register_foreign_function((void*)&sumdivk,"sumdivk",1024);
  register_foreign_function((void*)&gsigne,"gsigne",1024);
  register_foreign_function((void*)&simplify,"simplify",1024);
  register_foreign_function((void*)&gsin,"gsin",1024);
  register_foreign_function((void*)&gsinc,"gsinc",1024);
  register_foreign_function((void*)&gsinh,"gsinh",1024);
  register_foreign_function((void*)&gsizebyte,"gsizebyte",1024);
  register_foreign_function((void*)&gsqr,"gsqr",1024);
  register_foreign_function((void*)&gsqrt,"gsqrt",1024);
  register_foreign_function((void*)&sqrtint,"sqrtint",1024);
  register_foreign_function((void*)&gsqrtn,"gsqrtn",1024);
  register_foreign_function((void*)&sqrtnint,"sqrtnint",1024);
  register_foreign_function((void*)&stirling,"stirling",1024);
  register_foreign_function((void*)&subgrouplist0,"subgrouplist0",1024);
  register_foreign_function((void*)&gsubst,"gsubst",1024);
  register_foreign_function((void*)&gsubstpol,"gsubstpol",1024);
  register_foreign_function((void*)&gsubstvec,"gsubstvec",1024);
  register_foreign_function((void*)&sumdedekind,"sumdedekind",1024);
  register_foreign_function((void*)&sumdigits0,"sumdigits0",1024);
  register_foreign_function((void*)&sumformal,"sumformal",1024);
  register_foreign_function((void*)&gpsystem,"gpsystem",1024);
  register_foreign_function((void*)&gtan,"gtan",1024);
  register_foreign_function((void*)&gtanh,"gtanh",1024);
  register_foreign_function((void*)&tayl,"tayl",1024);
  register_foreign_function((void*)&teichmuller,"teichmuller",1024);
  register_foreign_function((void*)&theta,"theta",1024);
  register_foreign_function((void*)&thetanullk,"thetanullk",1024);
  register_foreign_function((void*)&thue,"thue",1024);
  register_foreign_function((void*)&thueinit,"thueinit",1024);
  register_foreign_function((void*)&gtrace,"gtrace",1024);
  register_foreign_function((void*)&trunc0,"trunc0",1024);
  register_foreign_function((void*)&type0,"type0",1024);
  register_foreign_function((void*)&gpvaluation,"gpvaluation",1024);
  register_foreign_function((void*)&varhigher,"varhigher",1024);
  register_foreign_function((void*)&gpolvar,"gpolvar",1024);
  register_foreign_function((void*)&variables_vec,"variables_vec",1024);
  register_foreign_function((void*)&varlower,"varlower",1024);
  register_foreign_function((void*)&extract0,"extract0",1024);
  register_foreign_function((void*)&vecmax0,"vecmax0",1024);
  register_foreign_function((void*)&vecmin0,"vecmin0",1024);
  register_foreign_function((void*)&vecprod,"vecprod",1024);
  register_foreign_function((void*)&vecsearch,"vecsearch",1024);
  register_foreign_function((void*)&vecsort0,"vecsort0",1024);
  register_foreign_function((void*)&vecsum,"vecsum",1024);
  register_foreign_function((void*)&vecteur,"vecteur",1024);
  register_foreign_function((void*)&vecteursmall,"vecteursmall",1024);
  register_foreign_function((void*)&vvecteur,"vvecteur",1024);
  register_foreign_function((void*)&pari_version,"pari_version",1024);
  register_foreign_function((void*)&warning0,"warning0",1024);
  register_foreign_function((void*)&weber0,"weber0",1024);
  register_foreign_function((void*)&write0,"write0",1024);
  register_foreign_function((void*)&write1,"write1",1024);
  register_foreign_function((void*)&gpwritebin,"gpwritebin",1024);
  register_foreign_function((void*)&writetex,"writetex",1024);
  register_foreign_function((void*)&gzeta,"gzeta",1024);
  register_foreign_function((void*)&zetahurwitz,"zetahurwitz",1024);
  register_foreign_function((void*)&zetamult0,"zetamult0",1024);
  register_foreign_function((void*)&zetamultall,"zetamultall",1024);
  register_foreign_function((void*)&zetamultconvert,"zetamultconvert",1024);
  register_foreign_function((void*)&zetamultinit,"zetamultinit",1024);
  register_foreign_function((void*)&znchar,"znchar",1024);
  register_foreign_function((void*)&zncharconductor,"zncharconductor",1024);
  register_foreign_function((void*)&znchardecompose,"znchardecompose",1024);
  register_foreign_function((void*)&znchargauss,"znchargauss",1024);
  register_foreign_function((void*)&zncharinduce,"zncharinduce",1024);
  register_foreign_function((void*)&zncharisodd,"zncharisodd",1024);
  register_foreign_function((void*)&znchartokronecker,"znchartokronecker",1024);
  register_foreign_function((void*)&znchartoprimitive,"znchartoprimitive",1024);
  register_foreign_function((void*)&znconreychar,"znconreychar",1024);
  register_foreign_function((void*)&znconreyconductor,"znconreyconductor",1024);
  register_foreign_function((void*)&znconreyexp,"znconreyexp",1024);
  register_foreign_function((void*)&znconreylog,"znconreylog",1024);
  register_foreign_function((void*)&zncoppersmith,"zncoppersmith",1024);
  register_foreign_function((void*)&znlog0,"znlog0",1024);
  register_foreign_function((void*)&znorder,"znorder",1024);
  register_foreign_function((void*)&znprimroot,"znprimroot",1024);
  register_foreign_function((void*)&znstar0,"znstar0",1024);
  register_foreign_function((void*)&iscomplex,"iscomplex",1024);
  register_foreign_function((void*)&isexactzero,"isexactzero",1024);
  register_foreign_function((void*)&isrationalzeroscalar,"isrationalzeroscalar",1024);
  register_foreign_function((void*)&isinexact,"isinexact",1024);
  register_foreign_function((void*)&isinexactreal,"isinexactreal",1024);
  register_foreign_function((void*)&isint,"isint",1024);
  register_foreign_function((void*)&isrationalzero,"isrationalzero",1024);
  register_foreign_function((void*)&issmall,"issmall",1024);
  register_foreign_function((void*)&primpart,"primpart",1024);
  register_foreign_function((void*)&primitive_part,"primitive_part",1024);
  register_foreign_function((void*)&pol_0,"pol_0",1024);
  register_foreign_function((void*)&pol_1,"pol_1",1024);
  register_foreign_function((void*)&pol_x,"pol_x",1024);
  register_foreign_function((void*)&scalarcol,"scalarcol",1024);
  register_foreign_function((void*)&scalarmat,"scalarmat",1024);
  register_foreign_function((void*)&galois_group,"galois_group",1024);
  register_foreign_function((void*)&idealaddmultoone,"idealaddmultoone",1024);
  register_foreign_function((void*)&caradj,"caradj",1024);
  register_foreign_function((void*)&ellrandom,"ellrandom",1024);
  register_foreign_function((void*)&ffrandom,"ffrandom",1024);
  register_foreign_function((void*)&ginv,"ginv",1024);
  register_foreign_function((void*)&nfinv,"nfinv",1024);
  register_foreign_function((void*)&gequal0,"gequal0",1024);
  register_foreign_function((void*)&gequal1,"gequal1",1024);
  register_foreign_function((void*)&gequalm1,"gequalm1",1024);
  register_foreign_function((void*)&gequal,"gequal",1024);
  register_foreign_function((void*)&gsizeword,"gsizeword",1024);
  register_foreign_function((void*)&MODULE__PARI__CONSTANT_MAP_C_STRING,"MODULE__PARI__CONSTANT_MAP_C_STRING",1024);
  register_foreign_function((void*)&MODULE__PARI__CONSTANT_MAP_LONG,"MODULE__PARI__CONSTANT_MAP_LONG",1024);
  register_foreign_function((void*)&MODULE__PARI__CONSTANT_MAP_ULONG,"MODULE__PARI__CONSTANT_MAP_ULONG",1024);
}

void module__pari__fini_function (module_t* module)
{
  (void)module; /* avoid -Wunused-parameter */

  
pari_close();

}
